﻿;/------------------------
;|
;| Dialog Design0R
;| ©HeX0R 2019
;| Last Update: 20.06.2019
;|
;| http://hex0rs.coderbu.de/dialogdesign0r
;|
;| Simple but powerful dialog designer
;|
;| Thanks to Shardik and Omi for the Linux and MacOS Api!
;|
;|
;| Icons from http://www.fatcow.com/free-icons 
;| Really amazing amount of very cool free icons!!
;|
;/------------------------

; ----------------------------------------------------------------------------
; "THE BEER-WARE LICENSE":
; <HeX0R@coderbu.de> wrote this file. as long as you retain this notice you
; can do whatever you want with this stuff. If we meet some day, and you think
; this stuff is worth it, you can buy me a beer in return
; (see address on http://hex0rs.coderbu.de/).
; Or just go out and drink a few on your own/with your friends ;)
;=============================================================================

#MY_VERSION = "V1.49"


UsePNGImageDecoder()
;{ - OS Specific Things

CompilerSelect #PB_Compiler_OS
	CompilerCase #PB_OS_Linux
		
		CompilerIf Subsystem("qt")
			
			Procedure DoTreeAutoScroll(Gadget, yPos, SelectedIndex)
				;TODO TreeAutoScroll for linux qt
				
			EndProcedure
			
			Procedure GetTreeItemBelowCursor(Gadget, x, y)
				;TODO GetTreeItemBelowCursor for linux gt
				
			EndProcedure
			
		CompilerElse
			ImportC ""
				g_object_set(*object.GObject, property_name.p-utf8, *data, value= 0)
			EndImport
			
			g_object_set(gtk_settings_get_default_(), "gtk-entry-select-on-focus", #False)
			
			;- for TreeGadget. Conversion from PathString (e.g. 2:5:1) to continous ItemIndex (PB)
			Structure TREEVIEWDATA
				Path.l
				;    SearchIndex.l
				ItemIndex.l
				PathString.s
			EndStructure
			
			Global TreeForEach_Data.TREEVIEWDATA
			
			ProcedureC Callback_TreeForEach2Index(*Model, *Path, *Iter, *userdata.TREEVIEWDATA);!
				If PeekS(gtk_tree_path_to_string_(*Path), -1 ,#PB_UTF8)= *userdata\PathString
					ProcedureReturn #True
				Else
					*userdata\ItemIndex + 1
					ProcedureReturn #False   
				EndIf
			EndProcedure
			
			Procedure.i TV_ItemIndexFromPathString(Gadget, PathString.s)
				Protected iter.GtkTreeIter
				Protected tPath
				Protected *tModel= gtk_tree_view_get_model_(GadgetID(Gadget))
				
				gtk_tree_model_get_iter_first_(*tModel, @iter)
				tPath= gtk_tree_model_get_path_(*tModel, iter)
				If tPath
					TreeForEach_Data\ItemIndex  = 0
					TreeForEach_Data\Path       = tPath
					TreeForEach_Data\PathString = PathString
					gtk_tree_model_foreach_(*tModel, @Callback_TreeForEach2Index(), TreeForEach_Data)
					gtk_tree_path_free_(tPath); ???
				EndIf
				If TreeForEach_Data\ItemIndex>= CountGadgetItems(Gadget)
					TreeForEach_Data\ItemIndex= -1
				EndIf
				ProcedureReturn TreeForEach_Data\ItemIndex
			EndProcedure
			
			Procedure GetTreeItemBelowCursor(Gadget, x, y)
				Protected Result, *treepath, pos
				
				Result = -1
				gtk_tree_view_get_dest_row_at_pos_(GadgetID(Gadget), x, y, @*treepath, @pos)
				If *treepath
					;for TreeGadgets (get hierarchic numbering on nodes like 2:5:1) ...
					If PeekS(gtk_tree_path_to_string_(*treepath), -1, #PB_UTF8) <> ""; check necessary ?
						Result = TV_ItemIndexFromPathString(Gadget, PeekS(gtk_tree_path_to_string_(*treepath), -1, #PB_UTF8))
					EndIf
					;pos; is relative position see: https://developer.gnome.org/gtk3/stable/GtkTreeView.html#GtkTreeViewDropPosition
				EndIf
				
				ProcedureReturn Result
			EndProcedure
			
			Procedure DoTreeAutoScroll(Gadget, yPos, SelectedIndex)
				;TODO TreeAutoScroll for linux
				
			EndProcedure
			
		CompilerEndIf
		
		#EXT = "so"
		
		;- ---
	CompilerCase #PB_OS_Windows
		
		CompilerIf Defined(TVHITTESTINFO, #PB_Structure) = 0
			Structure TVHITTESTINFO
				pt.POINT
				flags.l
				hItem.i
			EndStructure
		CompilerEndIf
		
		Procedure GetTreeItemBelowCursor(Gadget, x, y)
			Protected Result, TVITEM.TVITEM, TVHT.TVHITTESTINFO
			
			Result       = -1
			TVITEM\mask  = #TVIF_PARAM
			TVHT\pt\x    = x
			TVHT\pt\y    = y
			TVITEM\hItem = SendMessage_(GadgetID(Gadget), #TVM_HITTEST, 0, @TVHT)
			If TVITEM\hItem
				SendMessage_(GadgetID(Gadget), #TVM_GETITEM, 0, TVITEM) ;thanks to RSBasic
				Result = TVITEM\lParam
			EndIf
			
			ProcedureReturn Result
		EndProcedure
		
		Procedure DoTreeAutoScroll(Gadget, yPos, SelectedIndex)
			Protected Count, j
			
			If SelectedIndex > -1
				Count  = CountGadgetItems(Gadget)
				If yPos > 0 And yPos < 30
					;move it up
					j = SelectedIndex - 1
					If j >= 0
						SendMessage_(GadgetID(Gadget), #TVM_ENSUREVISIBLE, 0, GadgetItemID(Gadget, j))
					EndIf
				ElseIf yPos > GadgetHeight(Gadget) - 30
					;move it down
					j = SelectedIndex + 1
					If j < Count
						SendMessage_(GadgetID(Gadget), #TVM_ENSUREVISIBLE, 0, GadgetItemID(Gadget, j))
					EndIf
				EndIf
			EndIf
		EndProcedure
		
		#EXT = "dll"
		
	CompilerCase #PB_OS_MacOS
		
		;TODO fix this damn procedure for MacOS
		
		Procedure GetTreeItemBelowCursor(Gadget, x, y)
			Protected H, Result, Frame.NSRect
			
			CocoaMessage(@Frame, GadgetID(Gadget), "frameOfOutlineCellAtRow:", 0)
			H = Frame\size\height
			Result = Int(y / H)
			
			ProcedureReturn Result
		EndProcedure
		
		;TODO TreeAutoScroll for MacOS
		
		Procedure DoTreeAutoScroll(Gadget, yPos, SelectedIndex)
		EndProcedure
		
		#EXT = "dylib"
		
CompilerEndSelect

;some os dependant macros
Macro M_InitializeSplitter(i)
	CompilerIf #PB_Compiler_OS <> #PB_OS_Linux
		;Linux is behaving strange here... better ignore the splitter for now
		SetGadgetState(DialogGadget(#Dialog_Main, "splitter"), i)
	CompilerEndIf
EndMacro

Macro M_GadgetDrop
	CompilerIf #PB_Compiler_OS = #PB_OS_Linux
		If EventGadget() = DID("tree_objects")
			OnObjectTreeDrop()
		EndIf
	CompilerEndIf
EndMacro

Macro M_InitSplitter
	CompilerIf #PB_Compiler_OS = #PB_OS_Linux
		;Damn linux, this crazy part below was the only chance to get the splitter correctly inititalized
		For j = i + 10 To i Step -1
			SetGadgetState(DialogGadget(#Dialog_Main, "splitter"), j)
			While WindowEvent() : Wend
			Delay(20)
		Next j
		RefreshDialog(#Dialog_Main)
	CompilerEndIf
EndMacro

Macro M_CloseSelectionWindows
	CompilerIf #PB_Compiler_OS = #PB_OS_Windows
		;Windows only! close the 4 micky mouse windows
		For j = 0 To 3
			If IsWindow(j)
				CloseWindow(j)
			EndIf
		Next j
	CompilerEndIf
EndMacro



;}
CompilerIf #PB_Compiler_Version < 540
	CompilerError "Please use at least PureBasic V 5.4x"
CompilerEndIf
CompilerIf #PB_Compiler_Version < 560
	#PB_Directory_ProgramData = 1
	Procedure.s GetUserDirectory(Mode)
		CompilerSelect #PB_Compiler_OS
			CompilerCase #PB_OS_Windows
				ProcedureReturn GetEnvironmentVariable("APPDATA") + "\"
			CompilerDefault
				ProcedureReturn GetHomeDirectory() + "."
		CompilerEndSelect
	EndProcedure
CompilerEndIf
CompilerIf #PB_Compiler_Unicode = 0
	CompilerError "Please compile in Unicode mode"
CompilerEndIf

EnableExplicit

;{ - Prototypes
Prototype AddOn_Init()
Prototype AddOn_LoadXML(FileName.s)
Prototype AddOn_SaveXML(FileName.s, XML.s)
Prototype AddOn_GetLastError()
Prototype AddOn_GetFileType(FileName.s)
;}

;{ - Constants

#Popup_Menu_Tree    = 0
#MainTitle          = "DialogDesign0R {VERSION} [{FILE}]       ©HeX0R {YEAR}"
#SelectBoxSize      = 8
#DD_VERSION_URL     = "http://coderbu.de/Versions/dd_version.json"

Enumeration Dialogs
	#Dialog_Main
	#Dialog_UserAttr
	#Dialog_Constants
	#Dialog_Preferences
	#Dialog_SwitchContainer
EndEnumeration

Enumeration Timers
	#Timer_Main
	#Timer_CheckUpdate
EndEnumeration

Enumeration XML
	#XML_Main
	#XML_Loaded
EndEnumeration

Enumeration Images
	#Image_UserAttr
	#Image_Comments
	#Image_Attr_Add
	#Image_Attr_Del
	#Image_Up
	#Image_Down
	#Image_Refresh
	#Image_New
	#Image_Open
	#Image_Save
	#Image_SaveAs
	#Image_ShowAll
	#Image_HideAll
	#Image_AddDialogs
	#Image_Preferences
	#Image_Copy
	#Image_Cut
	#Image_Paste
	#Image_Undo
	#Image_Redo
	#Image_Color
	#Image_SwitchContainer
	#Image_Donate
	#Image_Info
EndEnumeration

Enumeration DialogTypes
	#DialogType_Dialogs
	#DialogType_Window
	#DialogType_Button
	#DialogType_ButtonImage
	#DialogType_Calendar
	#DialogType_Canvas
	#DialogType_CheckBox
	#DialogType_ComboBox
	#DialogType_Container
	#DialogType_Date
	#DialogType_Editor
	#DialogType_Empty
	#DialogType_ExplorerCombo
	#DialogType_ExplorerList
	#DialogType_ExplorerTree
	#DialogType_Frame
	#DialogType_HyperLink
	#DialogType_Image
	#DialogType_IPAddress
	#DialogType_ListIcon
	#DialogType_ListView
	#DialogType_Option
	#DialogType_Panel
	#DialogType_ProgressBar
	#DialogType_Scintilla
	#DialogType_ScrollArea
	#DialogType_ScrollBar
	#DialogType_Spin
	#DialogType_Splitter
	#DialogType_String
	#DialogType_Tab
	#DialogType_Text
	#DialogType_TrackBar
	#DialogType_Tree
	#DialogType_Web
	#DialogType_HBox
	#DialogType_VBox
	#DialogType_GridBox
	#DialogType_MultiBox
	#DialogType_SingleBox
	;
	#TreeMenu_AddWindow
	#TreeMenu_MoveChildUp
	#TreeMenu_MoveChildDown
	#TreeMenu_AddComment
	#TreeMenu_Delete
	#TreeMenu_LoadAdditionalDialoge
	#TreeMenu_Copy
	#TreeMenu_Cut
	#TreeMenu_Paste
	#TreeMenu_SwitchContainer
	;
	#ShortCut_F2
 	#ShortCut_Delete
	#ShortCut_ShowAll
	#ShortCut_HideAll
	#ShortCut_Copy
	#ShortCut_Cut
	#ShortCut_Paste
	#ShortCut_OpenContextMenu
	#ShortCut_Debug
	#ShortCut_Undo
	#ShortCut_Redo
	;

	
EndEnumeration

Enumeration
	#Sel_LeftBottom
	#Sel_LeftTop
	#Sel_RightBottom
	#Sel_RightTop
EndEnumeration

Enumeration SubMenus
	#SubMenu_AddChilds
	#SubMenu_AddSingleContainer
	#SubMenu_AddMultiContainer
	#SubMenu_Comments
	;
	#SubMenu_Max
EndEnumeration

Enumeration #PB_Event_FirstCustomValue
	#Event_RefreshMainWindow
	#Event_RefreshDialog
EndEnumeration

Enumeration
	#Check_Nothing
	#Check_Copy
	#Check_Delete
	#Check_Paste
EndEnumeration

EnumerationBinary
	#Undo_Possible
	#Redo_Possible
EndEnumeration


;}

;{ - Structures
Structure _DIALOG_DATA_  ;used for map DD(), please see "LoadDialogTypeData()" and the DataSection on the bottom
	Type.i                 ;<- see enumeration above
	MaxChilds.i            ;<- how many childs can this type contain? -1 = unlimited
	UsableChilds.i         ;<- can we use any available child? (e.g. panel can only contain tab)
	PossibleFlags.s        ;<- flags, this type supports (texts, separated by |)
	MinSupport.b           ;<- does this type support the min attribute?
	MaxSupport.b           ;<- does this type support the max attribute?
	ValueSupport.b         ;<- does this type support the value attribute?
	GroupSupport.b				 ;<- does this type support the group attribute?
	PageSupport.b          ;<- does this type support the page attribute?
	ImageID.i							 ;<- Icon for the Tree
	CutImageID.i           ;<- Icon for Cut
	PossibleEvents.s       ;<- Any Gadget only supports some events! This will store the possible events
	AltName.s              ;<- Alternative name for the gadget (for special conditions)
	FlagsOrig.s            ;<- You can overwrite flag names, this one here keeps the original names
	FlagsNew.s             ;<- These are the new names.
EndStructure

Structure _OPEN_DIALOGS_ ;used for list OpenDialogs(), will keep the temporary open preview dialogs
	DialogID.i             ;<- the DialogID of this Dialog
	WindowID.i             ;<- the WindowID of this Window
	UpdateTimeOUT.i				 ;<- a delay timer to update the window
	UpdateSelection.i      ;<- a delay timer to update selected item (after resizing)
	*Node                  ;<- XML node of the <window> node for fast access
EndStructure

Structure _SORTHELPER_   ;used in temp. list SH(). Maps can't be sorted, but we want to have our menu items sorted, see "OpenWindow_Main()"
	Name.s                 ;<- Name, or MapKey of the according DD()
	*DD._DIALOG_DATA_      ;<- pointer to the DD() map item
EndStructure

Structure _ATTR_HELPER_  ;used in SwitchAttributes()
	Name.s
	Value.s
EndStructure

Structure _CUT_HELPER_
	*Node
	Index.i
	*DD._DIALOG_DATA_
EndStructure

Structure _ADD_ONS_
	DLL.i
	Name.s
	Extensions.s
	Init.AddOn_Init
	LoadXML.AddOn_LoadXML
	SaveXML.AddOn_SaveXML
	GetFileType.AddOn_GetFileType
	GetLastError.AddOn_GetLastError
EndStructure

Structure _SAVEDATAITEM_
	Header.s
	Item.s
	Footer.s
EndStructure

Structure _SAVEDATATEMPLATE_
	FileHeader.s
	FileFooter.s
	WinID._SAVEDATAITEM_
	WinName._SAVEDATAITEM_
	GadgetID._SAVEDATAITEM_
	GadgetName._SAVEDATAITEM_
	Proc._SAVEDATAITEM_
	XML._SAVEDATAITEM_
EndStructure

Structure _ONLINE_CHECK_
	VersionOnline.s
	VersionDate.i
	History.s
	URL.s
EndStructure

Structure _GADGET_SIZE_
	Top.i
	Bottom.i
	Left.i
	Right.i
EndStructure

Structure _LAN_
	Text.s
	ToolTipp.s
EndStructure


Structure _LAN_DIAGS_
	Title.s
	Map Gadget._LAN_()
EndStructure

Structure _GADGET_STATES_
	State.i
EndStructure

Structure _PANEL_HELPER_
	*TAB
	*PANEL
	Name.s
EndStructure
;}

;{ - Global Vars
Global NewMap DD._DIALOG_DATA_()                    ;stores all of the dialog types, like button, panel, window, ...
Global NewMap DID.i()												       ;used to keep the gadget IDs of our main window
Global NewList UnsupportedItems.i()                 ;*.def files not necessarily have to support all dialoge items
Global NewMap PossibleAttributes.i()                ;attributes which are allowed in dialoges
Global NewList OpenDialogs._OPEN_DIALOGS_()         ;stores temporary dialog/window-previews
Global NewMap UsedIDs.i()                           ;stores all of the id attributes
Global NewMap UsedNames.i()                         ;stores all of the name attributes
Global NewList AddOn._ADD_ONS_()										 ;stores the addon libraries
Global NewList *Undo()															 ;Undo list
Global NewMap LAN._LAN_DIAGS_()                     ;language phrases
Global NewMap DDD.i()																;keeps Dialog Numbers for language phrases
Global NewMap GSS._GADGET_STATES_()
Global ActiveFile.s                                 ;will keep the xml file name loaded (for the save button)
Global *DragNode 														       ;will keep the *Node of the currently dragged node
Global RefreshDelay.i												       ;Delay in ms, after the dialog will be automatically redrawn
Global NoRuntimeEvents.i										         ;*.def files can disallow runtime events
Global CommentColor.i                               ;comment color
Global NameCounter.i                                ;a counter which will increase whenever a item will be added, will be used as internal name attribute
Global *CopyNode																		;will keep the *Node of a copy/paste process
Global Cut._CUT_HELPER_
Global Dim SubMenuHandles.i(#SubMenu_Max)
Global ConstantWindowIsHidden.i
Global Template._SAVEDATATEMPLATE_
Global OL._ONLINE_CHECK_
Global NetworkAccessible = InitNetwork()
Global LastXML.s
Global MAIN_TITLE.s = ReplaceString(ReplaceString(#MainTitle, "{VERSION}", #MY_VERSION), "{YEAR}", Str(Year(Date())))
Global HttpHandle.i
Global UndoRedoPossible.i
;}

Procedure LogIT(Text.s)                             ;Log text in the log editor
	If Text
		Text = FormatDate("%hh:%ii:%ss", Date()) + " " + Text
	EndIf
	AddGadgetItem(DialogGadget(#Dialog_Main, "log"), -1, Text)
	;scroll to the bottom
	CompilerSelect #PB_Compiler_OS
		CompilerCase #PB_OS_Windows
			SendMessage_(GadgetID(DialogGadget(#Dialog_Main, "log")), #EM_SCROLLCARET, #SB_BOTTOM, 0)
		CompilerCase #PB_OS_Linux  ;Thanks to Dave: http://www.purebasic.fr/english/viewtopic.php?f=15&t=43753
			Protected *buffer, end_iter.GtkTextIter
			*buffer = gtk_text_view_get_buffer_(GadgetID(DialogGadget(#Dialog_Main, "log")))
			gtk_text_buffer_get_end_iter_(*buffer, @end_iter)
			gtk_text_view_scroll_mark_onscreen_(GadgetID(DialogGadget(#Dialog_Main, "log")), gtk_text_buffer_create_mark_(*buffer, "end_mark", @end_iter, #False))
		CompilerCase #PB_OS_MacOS ;Thanks to Shardik: http://www.purebasic.fr/german/viewtopic.php?p=345154#p345154
			Protected Range.NSRange\location = Len(GetGadgetText(DialogGadget(#Dialog_Main, "log")))
      CocoaMessage(0, GadgetID(DialogGadget(#Dialog_Main, "log")), "scrollRangeToVisible:@", @Range)
	CompilerEndSelect

EndProcedure

Procedure InitAddOns()                              ;Init Addon DLLs (for saving and loading XML files)
	Protected *String, DLL.i
	
	ClearList(AddOn())
	If ExamineDirectory(0, GetPathPart(ProgramFilename()), "*.*")
		While NextDirectoryEntry(0)
			If DirectoryEntryType(0) = #PB_DirectoryEntry_File
				If LCase(GetExtensionPart(DirectoryEntryName(0))) = #EXT And LCase(Left(DirectoryEntryName(0), 6)) = "addon_"
					DLL = OpenLibrary(#PB_Any, GetPathPart(ProgramFilename()) + DirectoryEntryName(0))
					If DLL
						AddElement(AddOn())
						AddOn()\LoadXML      = GetFunction(DLL, "AddOn_LoadXML")
						AddOn()\SaveXML      = GetFunction(DLL, "AddOn_SaveXML")		
						AddOn()\Init         = GetFunction(DLL, "AddOn_Init")
						AddOn()\GetLastError = GetFunction(DLL, "AddOn_GetLastError")
						AddOn()\GetFileType  = GetFunction(DLL, "AddOn_GetFileType")
						If AddOn()\Init() = 0 Or AddOn()\LoadXML = 0 Or AddOn()\SaveXML = 0 Or AddOn()\GetLastError = 0
							;no correct addon dll!
							CloseLibrary(DLL)
							DeleteElement(AddOn())
						Else
							*String = AddOn()\Init()
							If *String = 0 Or PeekS(*String, 4) = ""
								CloseLibrary(DLL)
								DeleteElement(AddOn())
							Else
								AddOn()\Extensions = "|" + PeekS(*String) + "|"
								AddOn()\DLL        = DLL
								AddOn()\Name       = Mid(DirectoryEntryName(0), 7)
								AddOn()\Name       = Left(AddOn()\Name, Len(AddOn()\Name) - 1 - Len(#EXT))
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		Wend
		FinishDirectory(0)
	EndIf
	If FileSize(GetPathPart(ProgramFilename()) + "save_template.json") > 0
		If LoadJSON(0, GetPathPart(ProgramFilename()) + "save_template.json")
			ExtractJSONStructure(JSONValue(0), @Template, _SAVEDATATEMPLATE_)
			FreeJSON(0)
		Else
			LogIT(ReplaceString(ReplaceString(ReplaceString(LAN("other")\Gadget("OL_001")\Text, "{MSG}", JSONErrorMessage()), "{LINE}", Str(JSONErrorLine())), "{POS}", Str(JSONErrorPosition())))
		EndIf
	EndIf

EndProcedure

Procedure OpenOnlineURL(URL.s)                      ;Opens standard browser to show the update URL
	
	If URL
		CompilerSelect #PB_Compiler_OS
			CompilerCase #PB_OS_Windows
				RunProgram(URL)
			CompilerCase #PB_OS_Linux
				RunProgram("xdg-open", URL, GetCurrentDirectory())
			CompilerCase #PB_OS_MacOS
				RunProgram("open", URL, GetCurrentDirectory())
		CompilerEndSelect
	EndIf

EndProcedure

Procedure GetMaxLength(Block.s)                     ;Get max length from a bunch of Window/Gadget names to create a nice output
	Protected i, Result, Count
	
	Count = CountString(Block, #CRLF$)
	For i = 1 To Count
		If Len(StringField(Block, i, #CRLF$)) > Result
			Result = Len(StringField(Block, i, #CRLF$))
		EndIf
	Next i
	
	ProcedureReturn Result
EndProcedure

                                                     ;Helper procedure for DoConstantsOutputToFile()
Procedure DoConstantsOutputToFileItem(FID, Block.s, Header.s, Item.s, Footer.s)
	Protected i, a$, b$, c$, Length, Count, Search$
	
	If Block
		WriteString(FID, Header)
		CompilerSelect #PB_Compiler_OS
			CompilerCase #PB_OS_Linux
				Search$ = #LF$
			CompilerCase #PB_OS_MacOS
				Search$ = #CR$
			CompilerDefault
				Search$ = #CRLF$
		CompilerEndSelect
			
		
		Count  = CountString(Block, Search$)
		Length = GetMaxLength(Block) + 1
		c$     = Space(Length)
		For i = 1 To Count
			a$ = StringField(Block, i, Search$)
			a$ = RemoveString(RemoveString(ReplaceString(a$, #DQUOTE$, "'"), #LF$), #CR$)
			b$ = ReplaceString(Item, "{NAME}", a$)

			WriteString(FID, ReplaceString(b$, "{SPACE}", Left(c$, Length - Len(a$))))
		Next i
		WriteStringN(FID, Footer)
	EndIf
EndProcedure
                                                     ;Stores the contants/procedures in an additional file
Procedure DoConstantsOutputToFile(FileName.s, WinIDs.s, WinNames.s, GadgetIDs.s, GadgetNames.s, Proc.s)
	Protected FID, Count
	
	If WinIDs Or WinNames Or GadgetIDs Or GadgetNames Or Proc
		FID = CreateFile(#PB_Any, FileName, #PB_UTF8)
		If FID
			WriteStringFormat(FID, #PB_UTF8)
			WriteString(FID, Template\FileHeader)
			DoConstantsOutputToFileItem(FID, WinIDs,      Template\WinID\Header,      Template\WinID\Item,      Template\WinID\Footer)
			DoConstantsOutputToFileItem(FID, WinNames,    Template\WinName\Header,    Template\WinName\Item,    Template\WinName\Footer)
			DoConstantsOutputToFileItem(FID, GadgetIDs,   Template\GadgetID\Header,   Template\GadgetID\Item,   Template\GadgetID\Footer)
			DoConstantsOutputToFileItem(FID, GadgetNames, Template\GadgetName\Header, Template\GadgetName\Item, Template\GadgetName\Footer)
			DoConstantsOutputToFileItem(FID, Proc,        Template\Proc\Header,       Template\Proc\Item,       Template\Proc\Footer)
			If GetGadgetState(DialogGadget(#Dialog_Main, "check_storexml")) And LastXML <> ""
				DoConstantsOutputToFileItem(FID, LastXML + #CRLF$, Template\XML\Header, Template\XML\Item, Template\XML\Footer)
			EndIf
			WriteString(FID, Template\FileFooter)
			CloseFile(FID)
			LogIT(ReplaceString(LAN("other")\Gadget("OL_002")\Text, "{FILE}", GetFilePart(FileName)))
		EndIf
	EndIf
	
EndProcedure

Procedure DoConstantsOutput(FileName.s = "")        ;Add all IDs and Names to an editor gadget
	Protected i, Count, *Node, ID.s, Name.s, Type, a$, b$, GID
	Protected WinIDs.s, WinNames.s, GadgetIDs.s, GadgetNames.s, Proc.s
	
	If FileName 
		If GetGadgetState(DialogGadget(#Dialog_Main, "check_storeadd")) = 0
			FileName = ""
		Else
			a$ = GetGadgetText(DialogGadget(#Dialog_Main, "definition"))
			Select LCase(a$)
				Case "purebasic"
					FileName + ".dd.pbi"
				Case "spiderbasic"
					FileName + ".dd.sbi"
				Default
					FileName = ""
			EndSelect
		EndIf
	EndIf
	
	GID = DialogGadget(#Dialog_Constants, "constants")
	ClearGadgetItems(GID)
	Count = CountGadgetItems(DID("tree_objects")) - 1
	For i = 0 To Count
		*Node = GetGadgetItemData(DID("tree_objects"), i)
		If *Node
			Type = XMLNodeType(*Node)
			a$   = ""
			If Type = #PB_XML_Normal
				ID   = GetXMLAttribute(*Node, "_id")
				Name = GetXMLAttribute(*Node, "_name")
				Select GetXMLNodeName(*Node)
					Case "window"
						If ID And LCase(ID) <> "#pb_any"
							WinIDs + ID + #CRLF$
						EndIf
						If Name
							WinNames + Name + #CRLF$
						EndIf
					Case "dialog", "vbox", "hbox", "singlebox", "multibox", "tab", "gridbox", "empty";, "tab"
						;do nothing
					Default
						If ID And LCase(ID) <> "#pb_any"
							GadgetIDs + ID + #CRLF$
						EndIf
						If Name
							GadgetNames + Name + #CRLF$
						EndIf
				EndSelect
				Restore ConstantSavingData
				Read.s a$
				While a$
					a$ = GetXMLAttribute(*Node, a$)
					If a$ And FindString(Proc, a$ + #CRLF$) = 0
						Proc + a$ + #CRLF$
					EndIf
					Read.s a$
				Wend
			EndIf
		EndIf
	Next i
	
	If WinIDs
		AddGadgetItem(GID, -1, "Window IDs:")
		AddGadgetItem(GID, -1, "")
		AddGadgetItem(GID, -1, WinIDs)
		AddGadgetItem(GID, -1, "")
	EndIf
	If WinNames
		AddGadgetItem(GID, -1, "Window Names:")
		AddGadgetItem(GID, -1, "")
		AddGadgetItem(GID, -1, WinNames)
		AddGadgetItem(GID, -1, "")
	EndIf
	If GadgetIDs
		AddGadgetItem(GID, -1, "Gadget IDs:")
		AddGadgetItem(GID, -1, "")
		AddGadgetItem(GID, -1, GadgetIDs)
		AddGadgetItem(GID, -1, "")
	EndIf
	If GadgetNames
		AddGadgetItem(GID, -1, "Gadget Names:")
		AddGadgetItem(GID, -1, "")
		AddGadgetItem(GID, -1, GadgetNames)
		AddGadgetItem(GID, -1, "")
	EndIf
	If Proc
		AddGadgetItem(GID, -1, "Runtime Procedures:")
		AddGadgetItem(GID, -1, "")
		AddGadgetItem(GID, -1, Proc)
		AddGadgetItem(GID, -1, "")
	EndIf
	
	If FileName
		DoConstantsOutputToFile(FileName, WinIDs, WinNames, GadgetIDs, GadgetNames, Proc)
	EndIf

	If CountGadgetItems(GID) > 0 And ConstantWindowIsHidden = 0
		HideWindow(DialogWindow(#Dialog_Constants), 0)
	Else
		HideWindow(DialogWindow(#Dialog_Constants), 1)
	EndIf
	
	
EndProcedure

                                                     ;Gets Gadget size and position
Procedure GetItemSize(*Node, DialogID, WindowID, *GS._GADGET_SIZE_, FirstRun = #True)
	Protected *Child, Name.s, GName.s, Result, i, GS2._GADGET_SIZE_
	
	Name = GetXMLNodeName(*Node)
	Select Name
		Case "window"
			*GS\Left = #SelectBoxSize / 2
			*GS\Top  = #SelectBoxSize / 2
			*GS\Bottom = WindowHeight(WindowID) - #SelectBoxSize / 2
			*GS\Right  = WindowWidth(WindowID) - #SelectBoxSize / 2
			Result     = #True
		Case "multibox", "singlebox", "gridbox", "vbox", "hbox"
			If FirstRun
				*GS\Left = 100000
				*GS\Top  = 100000
			EndIf
			GS2\Left = 100000
			GS2\Top  = 100000
			
			For i = 1 To XMLChildCount(*Node)
				*Child = ChildXMLNode(*Node, i)
				If XMLNodeType(*Child) = #PB_XML_Normal And GetItemSize(*Child, DialogID, WindowID, @GS2, #False)
					If GS2\Top < *GS\Top
						*GS\Top = GS2\Top
					EndIf
					If GS2\Left < *GS\Left
						*GS\Left = GS2\Left
					EndIf
					If GS2\Right > *GS\Right
						*GS\Right = GS2\Right
					EndIf
					If GS2\Bottom > *GS\Bottom
						*GS\Bottom = GS2\Bottom
					EndIf
				EndIf
			Next i
			If *GS\Left <> 100000 And *GS\Right <> 100000
				Result = #True
			EndIf
		Case "empty", "tab"
			;not supported for now
			Result = #False
		Default
			GName = GetXMLAttribute(*Node, "name")
			If IsGadget(DialogGadget(DialogID, GName))
				*GS\Left   = GadgetX(DialogGadget(DialogID, GName), #PB_Gadget_WindowCoordinate)
				*GS\Bottom = GadgetY(DialogGadget(DialogID, GName), #PB_Gadget_WindowCoordinate) + GadgetHeight(DialogGadget(DialogID, GName))
				*GS\Right  = GadgetX(DialogGadget(DialogID, GName), #PB_Gadget_WindowCoordinate) + GadgetWidth(DialogGadget(DialogID, GName))
				*GS\Top    = GadgetY(DialogGadget(DialogID, GName), #PB_Gadget_WindowCoordinate)
				Result     = #True
			EndIf
	EndSelect

	ProcedureReturn Result
EndProcedure

Procedure CheckPanel(*Node)                         ;Checks if selected item is on a panel and will switch tabs accordingly
	Protected Name.s, i, *Parent, *TAB, *Panel, *Window, Count, TabIndex, DID
	
	NewList PH._PANEL_HELPER_()
	
	Repeat
		If GetXMLNodeName(*Node) = "tab"
			AddElement(PH())
			PH()\TAB = *Node
		EndIf
		*Parent = ParentXMLNode(*Node)
		If *Parent
			If XMLNodeType(*Parent) = #PB_XML_Normal 
				If GetXMLNodeName(*Parent) = "panel" And ListIndex(PH()) > -1
					PH()\PANEL = *Parent
					PH()\Name  = GetXMLAttribute(*Parent, "name")
					*Node      = *Parent
				ElseIf GetXMLNodeName(*Parent) = "window"
					*Window = *Parent
					Break
				Else
					*Node = *Parent
				EndIf
			Else
				Break
			EndIf
		Else
			Debug "no parent ??"
			Break
		EndIf
	ForEver
	
	If ListSize(PH()) > 0 And *Window
		PushListPosition(OpenDialogs())
		ForEach OpenDialogs()
			If OpenDialogs()\Node = *Window
				DID = OpenDialogs()\DialogID
				Break
			EndIf
		Next
		PopListPosition(OpenDialogs())
		
		LastElement(PH())
		Repeat
			Count    = XMLChildCount(PH()\PANEL)
			TabIndex = 0
			For i = 1 To Count
				*Node = ChildXMLNode(PH()\PANEL, i)
				If XMLNodeType(*Node) = #PB_XML_Normal
					TabIndex + 1
					If *Node = PH()\TAB
						SetGadgetState(DialogGadget(DID, PH()\Name), TabIndex - 1)
						Break
					EndIf
				EndIf
			Next i
		Until PreviousElement(PH()) = 0
	EndIf
	
EndProcedure

Procedure ItemSelect(*Node = 0)                     ;Will mark the selected item with 4 boxes in each corner
	Protected *Win, WindowID, DialogID, GadgetID, i, j, GS._GADGET_SIZE_, x, y, CurrGadget
	
	CurrGadget = GetActiveGadget()
	For i = 0 To 3
		CompilerIf #PB_Compiler_OS = #PB_OS_Windows
; 			If IsWindow(i)
; 				CloseWindow(i)
; 			EndIf
		CompilerElse
			If IsGadget(i)
				FreeGadget(i)
			EndIf
		CompilerEndIf
	Next
	
	If *Node = 0
		i = GetGadgetState(DID("tree_objects"))
		If i = -1
			M_CloseSelectionWindows
			SetActiveGadget(CurrGadget)
			ProcedureReturn 0
		EndIf
		*Node = GetGadgetItemData(DID("tree_objects"), i)
	EndIf
	
	If XMLNodeType(*Node) <> #PB_XML_Normal
		M_CloseSelectionWindows
 		SetActiveGadget(CurrGadget)
		ProcedureReturn 0
	EndIf
	
	*Win = *Node
	Repeat 
		If XMLNodeType(*Win) = #PB_XML_Normal And LCase(GetXMLNodeName(*Win)) = "window"
			Break
		EndIf
		*Win = ParentXMLNode(*Win)
	Until *Win = 0
	
	If *Win
		PushListPosition(OpenDialogs())
		ForEach OpenDialogs()
			If OpenDialogs()\Node = *Win
				WindowID = OpenDialogs()\WindowID
				DialogID = OpenDialogs()\DialogID
				Break
			EndIf
		Next
		PopListPosition(OpenDialogs())
	EndIf
	
	If WindowID And DialogID
		If GetItemSize(*Node, DialogID, WindowID, @GS)
			x = WindowX(WindowID, #PB_Window_InnerCoordinate)
			y = WindowY(WindowID, #PB_Window_InnerCoordinate)
			CompilerIf #PB_Compiler_OS = #PB_OS_Windows
				If IsWindowVisible_(WindowID(WindowID))
					If IsWindow(#Sel_LeftTop)
						ResizeWindow(#Sel_LeftTop,     x + GS\Left  - #SelectBoxSize / 2, y + GS\Top    - #SelectBoxSize / 2, #PB_Ignore, #PB_Ignore)
						ResizeWindow(#Sel_LeftBottom,  x + GS\Left  - #SelectBoxSize / 2, y + GS\Bottom - #SelectBoxSize / 2, #PB_Ignore, #PB_Ignore)
						ResizeWindow(#Sel_RightTop,    x + GS\Right - #SelectBoxSize / 2, y + GS\Top    - #SelectBoxSize / 2, #PB_Ignore, #PB_Ignore)
						ResizeWindow(#Sel_RightBottom, x + GS\Right - #SelectBoxSize / 2, y + GS\Bottom - #SelectBoxSize / 2, #PB_Ignore, #PB_Ignore)
					Else
						OpenWindow(#Sel_LeftTop,     x + GS\Left  - #SelectBoxSize / 2, y + GS\Top    - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize, "", #PB_Window_BorderLess, WindowID(WindowID)) : SetWindowColor(#Sel_LeftTop, $0000FF)
						OpenWindow(#Sel_LeftBottom,  x + GS\Left  - #SelectBoxSize / 2, y + GS\Bottom - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize, "", #PB_Window_BorderLess, WindowID(WindowID)) : SetWindowColor(#Sel_LeftBottom, $0000FF)
						OpenWindow(#Sel_RightTop,    x + GS\Right - #SelectBoxSize / 2, y + GS\Top    - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize, "", #PB_Window_BorderLess, WindowID(WindowID)) : SetWindowColor(#Sel_RightTop, $0000FF)
						OpenWindow(#Sel_RightBottom, x + GS\Right - #SelectBoxSize / 2, y + GS\Bottom - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize, "", #PB_Window_BorderLess, WindowID(WindowID)) : SetWindowColor(#Sel_RightBottom, $0000FF)
						SetActiveGadget(CurrGadget)	
					EndIf
				Else
					M_CloseSelectionWindows
				EndIf
			CompilerElse
	 			UseGadgetList(WindowID(WindowID))
	 			CanvasGadget(#Sel_LeftTop,     GS\Left  - #SelectBoxSize / 2, GS\Top    - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize)
	 			CanvasGadget(#Sel_LeftBottom,  GS\Left  - #SelectBoxSize / 2, GS\Bottom - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize)
	 			CanvasGadget(#Sel_RightTop,    GS\Right - #SelectBoxSize / 2, GS\Top    - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize)
	 			CanvasGadget(#Sel_RightBottom, GS\Right - #SelectBoxSize / 2, GS\Bottom - #SelectBoxSize / 2, #SelectBoxSize, #SelectBoxSize)
	 			For i = 0 To 3
					If IsGadget(i) And StartDrawing(CanvasOutput(i))
						Box(0, 0, OutputWidth(), OutputHeight(), $000000)
						Box(1, 1, OutputWidth() - 2, OutputHeight() - 2, $0000FF)
						StopDrawing()
					EndIf
				Next i
				SetActiveGadget(CurrGadget)
			CompilerEndIf
		EndIf
	Else
		M_CloseSelectionWindows
	EndIf

	
EndProcedure

Procedure SelectDDFromTree()                        ;Will return the selected *node and also select the DD() map item
	Protected Index, *Node
	
	Index = GetGadgetState(DID("tree_objects"))	
	If Index > -1
		*Node = GetGadgetItemData(DID("tree_objects"), Index)
		If XMLNodeType(*Node) = #PB_XML_Normal And FindMapElement(DD(), GetXMLNodeName(*Node)) = 0
			*Node = 0
		EndIf
	EndIf
	
	ProcedureReturn *Node
EndProcedure

Procedure MyXMLChildCount(*node)                    ;used to count childs and ignore comments
	Protected Result, R, i, *child
	
	Result = XMLChildCount(*node)
	R      = Result
	For i = 1 To R
		*child = ChildXMLNode(*node, i)
		If XMLNodeType(*child) = #PB_XML_Comment
			Result - 1
		EndIf
	Next i
	
	ProcedureReturn Result
EndProcedure

Procedure ResetMarginCombo()                        ;reset Margin ComboBox to default values
	Protected i

	ClearGadgetItems(DID("margincombo"))
	For i = 1 To 6
		AddGadgetItem(DID("margincombo"),  -1, StringField("top:,left:,right:,bottom:,vertical:,horizontal:", i, ","))
	Next i
EndProcedure

Procedure DisableAll(Mode)                          ;en/disable visible gadgets
	ForEach DID()
		Select MapKey(DID())
			Case "_id", "_name", "text", "min", "max", "value", "colspan", "rowspan", "width", "height", "flags", "invisible", "disabled", "group", "onevents", "onevent_proc", "page", "userattributes", "refresh"
				DisableGadget(DID(), Mode)
		EndSelect
	Next
	DisableGadget(DialogGadget(#Dialog_Main, "move_up"), Mode)
	DisableGadget(DialogGadget(#Dialog_Main, "move_down"), Mode)
EndProcedure

Procedure Undo_Init()                               ;Initialize the undo functionality
	ForEach *Undo()
		FreeMemory(*Undo())
	Next
	ClearList(*Undo())
	DisableGadget(DialogGadget(#Dialog_Main, "undo"), 1)
	DisableGadget(DialogGadget(#Dialog_Main, "redo"), 1)
	UndoRedoPossible = 0
EndProcedure

Procedure Undo_Add()                                ;Add an undo step
	Protected Size, *mem, *Last
	
	Size = ExportXMLSize(#XML_Loaded, #PB_XML_NoDeclaration)
	If Size
		*mem = AllocateMemory(Size)
		If *mem
			If ExportXML(#XML_Loaded, *mem, Size, #PB_XML_NoDeclaration)
				;o.k. export worked fine, now check, if there is something new, or this is maybe the very first undo step
				If ListIndex(*Undo()) = -1 Or Size <> MemorySize(*Undo()) Or CompareMemory(*mem, *Undo(), Size) = 0
					AddElement(*Undo())
					*Undo() = *mem
					;clear redo things
					PushListPosition(*Undo())
					While NextElement(*Undo())
						FreeMemory(*Undo())
						DeleteElement(*Undo())
					Wend
					PopListPosition(*Undo())
					UndoRedoPossible = 0
					DisableGadget(DialogGadget(#Dialog_Main, "redo"), 1)
					If ListSize(*Undo()) = 2
						DisableGadget(DialogGadget(#Dialog_Main, "undo"), 0)
						UndoRedoPossible = #Undo_Possible
					EndIf
				Else
					FreeMemory(*mem)
				EndIf
			Else
				FreeMemory(*mem)
			EndIf
		EndIf
	EndIf
	
EndProcedure

Procedure.s GetTempName(Type.s)                     ;will create temporary names of the nodes, e.g. window_1, tree_2, ...
	Protected Result.s, a$, j, Count
	Protected *Node, i, Max.i
	
	Count = CountGadgetItems(DID("tree_objects")) - 1
	For i = 0 To Count
		*Node = GetGadgetItemData(DID("tree_objects"), i)
		If XMLNodeType(*Node) = #PB_XML_Normal
			If GetXMLNodeName(*Node) = Type
				a$ = GetXMLAttribute(*Node, "_name")
				j  = Val(Mid(a$, Len(Type) + 2))
				If j > Max
					Max = j
				EndIf
			EndIf
		EndIf
	Next
	
	Result = Type + "_" + Str(Max + 1)
	ProcedureReturn Result
EndProcedure

Procedure LoadDefinition()                          ;load *.def file, to be able to use Design0r also for other languages (e.g. SpiderBasic)
	Protected Pos, FileName.s, S
	
	ClearList(UnsupportedItems())
	Pos = GetGadgetState(DialogGadget(#Dialog_Main, "definition"))
	If Pos > 0
		FileName = GetPathPart(ProgramFilename()) + GetGadgetItemText(DialogGadget(#Dialog_Main, "definition"), Pos) + ".def"
	EndIf
	OpenPreferences(FileName)
	PreferenceGroup("runtimeevents")
	NoRuntimeEvents = 1
	If ReadPreferenceInteger("supported", 1)
		NoRuntimeEvents = 0
	EndIf
	ForEach DD()
		PreferenceGroup(MapKey(DD()))
		DD()\AltName   = ReadPreferenceString("alt_name", "")
		DD()\FlagsOrig = ReadPreferenceString("flags_orig", "")
		DD()\FlagsNew  = ReadPreferenceString("flags_new", "")
		If Pos > 0
			S = ReadPreferenceInteger("supported", 0)
			If S = 0
				AddElement(UnsupportedItems())
				UnsupportedItems() = DD()\Type
			ElseIf S = 2
				;all flags supported!
				DD()\FlagsOrig = DD()\PossibleFlags
				DD()\FlagsNew  = DD()\PossibleFlags
			EndIf
		EndIf
	Next
	ClosePreferences()
EndProcedure

Procedure UpdateDialog(*Node, Delayed.i = 0)        ;will set the UpdateTimeOUT of this dialog, the real update is done in the timer procedure OnTimerEvent() then
		
	Repeat 
		If XMLNodeType(*Node) = #PB_XML_Normal And LCase(GetXMLNodeName(*Node)) = "window"
			Break
		EndIf
		*Node = ParentXMLNode(*Node)
	Until *Node = 0
	
	;if we would have the possibility to update a dialog on-the-run, this would be a uber-feature.
	;until now, we will update the dialog after a delay
	If *Node
		If XMLNodeType(*Node) = #PB_XML_Normal
			ForEach OpenDialogs()
				If OpenDialogs()\Node = *Node
					OpenDialogs()\UpdateTimeOUT = ElapsedMilliseconds() + Delayed
					Break
				EndIf
			Next
		EndIf
	EndIf
EndProcedure

Runtime Procedure OnClickRefresh()                 ;user clicked on the refresh button, refresh dialog (and show it, if it is still hidden)
	Protected i
	
	i = GetGadgetState(DID("tree_objects"))
	If i > 0
		UpdateDialog(GetGadgetItemData(DID("tree_objects"), i))
	EndIf
EndProcedure

Procedure OnSizeWindow()                            ;User resized dialog
	Protected Win, Found = #False
	
	Win = EventWindow()
	ForEach OpenDialogs()
		If OpenDialogs()\WindowID = Win
			Found = #True
			Break
		EndIf
	Next
	If Found
		OpenDialogs()\UpdateSelection = ElapsedMilliseconds() + 100
	EndIf
	
EndProcedure

CompilerIf #PB_Compiler_OS = #PB_OS_Windows         ;Make sure that the selection frame of the items will move when window moves (works only in windows)
	Procedure OnMoveWindow()
		Protected Win, Found = #False
	
		Win = EventWindow()
		ForEach OpenDialogs()
			If OpenDialogs()\WindowID = Win
				Found = #True
				Break
			EndIf
		Next
		If Found
			ItemSelect()
		EndIf
	
	EndProcedure
CompilerEndIf
	
Procedure StartUpDialog(*Node)                      ;Initialize dialog
	Protected Attr.s, DID, FlagsOrig.s, FlagsChanged.s, ok
	
	DID  = CreateDialog(#PB_Any)
	Attr = GetXMLAttribute(*node, "name")
	AddElement(OpenDialogs())
	OpenDialogs()\DialogID        = DID
	OpenDialogs()\Node            = *Node
	OpenDialogs()\UpdateTimeOUT   = 0
	OpenDialogs()\UpdateSelection = 0
	
	FlagsOrig    = GetXMLAttribute(*Node, "flags")
	FlagsChanged = FlagsOrig
	If FlagsOrig = ""
		FlagsChanged = "#PB_Window_NoActivate | #PB_Window_Invisible"
	Else
		If FindString(FlagsOrig, "#PB_Window_NoActivate", 1, #PB_String_NoCase) = 0
			FlagsChanged + " | #PB_Window_NoActivate"
		EndIf
		If FindString(FlagsOrig, "#PB_Window_Invisible", 1, #PB_String_NoCase) = 0
			FlagsChanged + " | #PB_Window_Invisible"
		EndIf
	EndIf
	SetXMLAttribute(*Node, "flags", FlagsChanged)
	ok = OpenXMLDialog(DID, #XML_Loaded, Attr)
	SetXMLAttribute(*Node, "flags", FlagsOrig)
	If ok = 0
		LogIT(ReplaceString(ReplaceString(LAN("other")\Gadget("OL_003")\Text, "{FILE}", Attr), "{MSG}", DialogError(DID)))
		FreeDialog(DID)
	Else
		OpenDialogs()\WindowID = DialogWindow(DID)
		BindEvent(#PB_Event_SizeWindow, @OnSizeWindow(), OpenDialogs()\WindowID)
		CompilerIf #PB_Compiler_OS = #PB_OS_Windows
			BindEvent(#PB_Event_MoveWindow, @OnMoveWindow(), OpenDialogs()\WindowID)
		CompilerEndIf
	EndIf
EndProcedure

Procedure ShowAllDialogs()                          ;called as soon as a xml has been loaded, to open all included windows (hidden)
	Protected i, *Node, Name.s, Count
	
	Count = CountGadgetItems(DID("tree_objects")) - 1
	For i = 0 To Count
		*Node = GetGadgetItemData(DID("tree_objects"), i)
		If XMLNodeType(*Node) = #PB_XML_Normal
			Name = GetXMLNodeName(*node) 
    	If LCase(Name) = "window" 
    		StartUpDialog(*Node)
    	EndIf
    EndIf
	Next i
	
EndProcedure

Runtime Procedure OnClickHideAll()                 ;hide all windows
	Protected *Index
	
	;changed this due to linux jumps out of the procedure sometimes.
	ResetList(OpenDialogs())
	While NextElement(OpenDialogs())
		*Index = @OpenDialogs()
		If IsWindow(OpenDialogs()\WindowID)
			HideWindow(OpenDialogs()\WindowID, 1)
		EndIf
		ChangeCurrentElement(OpenDialogs(), *Index)
	Wend
	
EndProcedure

Runtime Procedure OnClickShowAll()                 ;show all windows
	Protected *Index
	
	;changed this due to linux jumps out of the procedure sometimes.
	ResetList(OpenDialogs())
	While NextElement(OpenDialogs())
		*Index = @OpenDialogs()
		If IsWindow(OpenDialogs()\WindowID)
			HideWindow(OpenDialogs()\WindowID, 0)
		EndIf
		ChangeCurrentElement(OpenDialogs(), *Index)
	Wend

EndProcedure

Runtime Procedure OnUpdateClick()                  ;when clicked, DD checks online for updates
	
	If NetworkAccessible And HttpHandle = 0
		HttpHandle = ReceiveHTTPMemory(#DD_VERSION_URL, #PB_HTTP_Asynchronous)
		If HttpHandle
			AddWindowTimer(DialogWindow(#Dialog_Main), #Timer_CheckUpdate, 100)
			LogIT(LAN("other")\Gadget("OL_045")\Text)
			DisableGadget(DialogGadget(#Dialog_Preferences, "update"), 1)
		EndIf
	EndIf
	
EndProcedure

                                                     ;saves/restores some settings of the preview windows
Procedure GetRestoreGadgetSettings(DID, *Node, Get = #True)
	Protected i, Name.s, ID.s, Count, GID
	
	If XMLNodeType(*Node) = #PB_XML_Normal
		Name = GetXMLNodeName(*Node)
		Select Name
			Case "panel", "option", "checkbox", "splitter", "trackbar"
				ID  = GetXMLAttribute(*Node, "name")
				GID = DialogGadget(DID, ID)
				If GID <> -1
					If Get
						GSS(ID)\State = GetGadgetState(GID)
					ElseIf FindMapElement(GSS(), ID)
						SetGadgetState(GID, GSS()\State)
					EndIf
				EndIf
		EndSelect
		Count = XMLChildCount(*Node)
		For i = 1 To Count
			GetRestoreGadgetSettings(DID, ChildXMLNode(*Node, i), Get)
		Next i
	EndIf
	
EndProcedure

Procedure OnRefreshDialog()                         ;helps to avoid disappearing imagebuttons, not sure if this is a windows-only problem?
	RefreshDialog(EventGadget())
EndProcedure

Procedure OnTimerEvent()                            ;timer event, will be called any 50ms and only used to take care of window updates
	Protected Name.s, SnapShot, FlagsOrig.s, FlagsChanged.s, DID, ok, DIDOld, x = #PB_Ignore, y = #PB_Ignore, ActiveGadget
	Protected *Buffer, JSON, Text$
	
	
	Select EventTimer()
			
		Case #Timer_Main
			ForEach OpenDialogs()
				If IsDialog(OpenDialogs()\DialogID)
					If OpenDialogs()\UpdateTimeOUT <> 0 And OpenDialogs()\UpdateTimeOUT <= ElapsedMilliseconds()
						ActiveGadget            = GetActiveGadget()
						DIDOld                  = OpenDialogs()\DialogID
						If OpenDialogs()\WindowID And IsWindow(OpenDialogs()\WindowID)
							x = WindowX(OpenDialogs()\WindowID)
							y = WindowY(OpenDialogs()\WindowID)
						EndIf
						OpenDialogs()\UpdateTimeOUT = 0
						DID = CreateDialog(#PB_Any)
						If DID
							ClearMap(GSS())
							GetRestoreGadgetSettings(DIDOld, OpenDialogs()\Node)
							OpenDialogs()\DialogID = DID
							Name         = GetXMLAttribute(OpenDialogs()\Node, "name")
							FlagsOrig    = GetXMLAttribute(OpenDialogs()\Node, "flags")
							FlagsChanged = FlagsOrig
							If FlagsOrig = ""
								FlagsChanged = "#PB_Window_NoActivate | #PB_Window_Invisible"
							Else
								If FindString(FlagsOrig, "#PB_Window_NoActivate", 1, #PB_String_NoCase) = 0
									FlagsChanged + " | #PB_Window_NoActivate"
								EndIf
								If FindString(FlagsOrig, "#PB_Window_Invisible", 1, #PB_String_NoCase) = 0
									FlagsChanged + " | #PB_Window_Invisible"
								EndIf
							EndIf
							SetXMLAttribute(OpenDialogs()\Node, "flags", FlagsChanged)
							ok = OpenXMLDialog(DID, #XML_Loaded, Name, x, y)
							SetXMLAttribute(OpenDialogs()\Node, "flags", FlagsOrig)
							If ok = 0
								LogIT(ReplaceString(LAN("other")\Gadget("OL_008")\Text, "{MSG}", DialogError(DID)))
							Else
								GetRestoreGadgetSettings(DID, OpenDialogs()\Node, #False)
								OpenDialogs()\WindowID = DialogWindow(DID)
								ResizeWindow(OpenDialogs()\WindowID, x, y, #PB_Ignore, #PB_Ignore)
								BindEvent(#PB_Event_SizeWindow, @OnSizeWindow(), OpenDialogs()\WindowID)
								CompilerIf #PB_Compiler_OS = #PB_OS_Windows
									BindEvent(#PB_Event_MoveWindow, @OnMoveWindow(), OpenDialogs()\WindowID)
								CompilerEndIf
								BindEvent(#Event_RefreshDialog, @OnRefreshDialog(), OpenDialogs()\WindowID)
								ItemSelect()
								HideWindow(OpenDialogs()\WindowID, 0)
								FreeDialog(DIDOld)
								;send a refresh to the end of the queue, to make sure no imagebuttons will be hidden
								PostEvent(#Event_RefreshDialog, OpenDialogs()\WindowID, OpenDialogs()\DialogID)
							EndIf
						EndIf
						If IsGadget(ActiveGadget)
							SetActiveGadget(ActiveGadget)
						EndIf
						If ok
; 							SetActiveWindow(OpenDialogs()\WindowID)
							CompilerIf #PB_Compiler_OS = #PB_OS_Linux
								RefreshDialog(DID)
							CompilerEndIf
						EndIf
						Undo_Add()
					ElseIf OpenDialogs()\UpdateTimeOUT <> 0 And OpenDialogs()\UpdateTimeOUT <= ElapsedMilliseconds()
						OpenDialogs()\UpdateTimeOUT = 0
						Undo_Add()
					ElseIf OpenDialogs()\UpdateSelection <> 0 And OpenDialogs()\UpdateSelection <= ElapsedMilliseconds()
						ItemSelect()
						OpenDialogs()\UpdateSelection = 0
					EndIf
				EndIf
			Next
			
		Case #Timer_CheckUpdate
			
			If HttpHandle
				Select HTTPProgress(HttpHandle)
					Case #PB_HTTP_Aborted, #PB_HTTP_Failed
						LogIT(LAN("other")\Gadget("OL_007")\Text)
						HttpHandle = #Null
					Case #PB_HTTP_Success
						*Buffer = FinishHTTP(HttpHandle)
						If *Buffer
							JSON = CatchJSON(#PB_Any, *Buffer, MemorySize(*Buffer))
							If JSON
								ExtractJSONStructure(JSONValue(JSON), @OL, _ONLINE_CHECK_)
								FreeJSON(JSON)
								If OL\VersionOnline > Mid(#MY_VERSION, 2)
									Text$ = ReplaceString(ReplaceString(LAN("other")\Gadget("OL_005")\Text, "{VER}", OL\VersionOnline), "{FROM}", FormatDate("%dd.%mm.%yyyy %hh:%ii", OL\VersionDate))
									Text$ = ReplaceString(Text$, "{HISTORY}", OL\History)
									If MessageRequester(LAN("other")\Gadget("OL_004")\Text, Text$, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
										OpenOnlineURL(OL\URL)
									EndIf
								Else
									LogIT(LAN("other")\Gadget("OL_006")\Text)
								EndIf
							Else
								LogIT(LAN("other")\Gadget("OL_007")\Text)
							EndIf
							FreeMemory(*Buffer)
						EndIf
						HttpHandle = #Null
					Default
						;not finished yet, wait
				EndSelect

				If HttpHandle = #Null
					RemoveWindowTimer(DialogWindow(#Dialog_Main), #Timer_CheckUpdate)
					DisableGadget(DialogGadget(#Dialog_Preferences, "update"), 0)
				EndIf

			EndIf
			
	EndSelect
	
	
EndProcedure

Procedure ClearTexts()                              ;clears all available gadgets
	Protected Key.s
	
	HideGadget(DialogGadget(#Dialog_Main, "container_window"),     1)
	HideGadget(DialogGadget(#Dialog_Main, "container_boxes"),      1)
	HideGadget(DialogGadget(#Dialog_Main, "container_gridbox"),    1)
	HideGadget(DialogGadget(#Dialog_Main, "container_multibox"),   1)
	HideGadget(DialogGadget(#Dialog_Main, "container_singlebox"),  1)
	HideGadget(DialogGadget(#Dialog_Main, "container_splitter"),   1)
	HideGadget(DialogGadget(#Dialog_Main, "container_scrollarea"), 1)
	HideGadget(DialogGadget(#Dialog_Main, "container_comment"),    1)
	HideGadget(DialogGadget(#Dialog_Main, "container_dialog"),     1)
	ClearGadgetItems(DID("onevents"))
	
	ForEach DID()
		Key = MapKey(DID())
		Select Key
			Case "invisible", "disabled"
				SetGadgetState(DID(), 0)
			Case "alignbox", "expandbox", "colexpand", "expandsingle", "rowexpand", "margincombo", "alignsingle"
				SetGadgetState(DID(), -1)
			Case "scrolling"
				SetGadgetState(DID(), 2)
			Case "flags"
				;will be cleared anyway
				ClearGadgetItems(DID())
			Case "tree_objects", "refresh", "refreshdelay", "refreshtime", "store_dialog", "save_add_file", "enable_color", "max_chars", "conf_del", "conf_close"
				;do nothing	
			Default
				SetGadgetText(DID(), "")
				Select Key
					Case "expandboxitem", "colexpanditem", "rowexpanditem"
						DisableGadget(DID(), 1)
				EndSelect
		EndSelect
	Next
EndProcedure

Runtime Procedure OnChangeAttribName()             ;user defined attribute name changed
	Protected a$, b$, i, j, k, GoOn, *node
	
	a$ = GetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_name"))
	If FindMapElement(PossibleAttributes(), a$)
		;do nothing we ignore this
	ElseIf FindString("|id|onevent|onchange|onfocus|onlostfocus|ondragstart|onrightclick|onleftclick|onrightdoubleclick|onleftdoubleclick|", "|" + a$ + "|")
		;do nothing we ignore this
	Else
		i = GetGadgetState(DialogGadget(#Dialog_UserAttr, "userattribs"))
		j = GetGadgetState(DID("tree_objects"))
		If i > -1 And j > -1
			GoOn = #True
			For k = 0 To CountGadgetItems(DialogGadget(#Dialog_UserAttr, "userattribs")) - 1
				If k <> i And GetGadgetItemText(DialogGadget(#Dialog_UserAttr, "userattribs"), k) = a$
					;double
					GoOn = #False
					Break
				EndIf
			Next k
			If GoOn
				b$ = GetGadgetItemText(DialogGadget(#Dialog_UserAttr, "userattribs"), i)
				SetGadgetItemText(DialogGadget(#Dialog_UserAttr, "userattribs"), i, a$)
				*node = GetGadgetItemData(DID("tree_objects"), j)
				RemoveXMLAttribute(*node, "_" + b$)
				SetXMLAttribute(*node, "_" + a$, GetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_value")))
				SetGadgetState(DialogGadget(#Dialog_UserAttr, "userattribs"), i)
			EndIf
		EndIf
	EndIf
			
EndProcedure

Runtime Procedure OnChangeAttribValue()            ;user defined attribute value changed
	Protected a$, b$, i, j, *node
	
	a$ = GetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_name"))
	If FindMapElement(PossibleAttributes(), a$)
		;do nothing we ignore this
	ElseIf FindString("|id|onevent|onchange|onfocus|onlostfocus|ondragstart|onrightclick|onleftclick|onrightdoubleclick|onleftdoubleclick|", "|" + a$ + "|")
		;do nothing we ignore this
	Else
		j = GetGadgetState(DID("tree_objects"))
		If j > -1
			*node = GetGadgetItemData(DID("tree_objects"), j)
			SetXMLAttribute(*node, "_" + a$, GetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_value")))
		EndIf
	EndIf
EndProcedure

Runtime Procedure OnClickAttribAdd()               ;add an user defined attribute
	Protected a$, b$, i, j, GoOn, *node
	
	a$ = "newattrib_"
	j  = 1
	Repeat
		GoOn = #True
		For i = 0 To CountGadgetItems(DialogGadget(#Dialog_UserAttr, "userattribs")) - 1
			If GetGadgetItemText(DialogGadget(#Dialog_UserAttr, "userattribs"), i) = a$ + Str(j)
				j + 1
				GoOn = #False
				Break
			EndIf
		Next i
	Until GoOn = #True
	
	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*node = GetGadgetItemData(DID("tree_objects"), i)
		SetXMLAttribute(*node, "_" + a$ + Str(j), "")
		AddGadgetItem(DialogGadget(#Dialog_UserAttr, "userattribs"), -1, a$ + Str(j))
		SetGadgetState(DialogGadget(#Dialog_UserAttr, "userattribs"), CountGadgetItems(DialogGadget(#Dialog_UserAttr, "userattribs")) - 1)
		SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_name"), a$ + Str(j))
		SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_value"), "")
		DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_name"), 0)
		DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_value"), 0)
	EndIf
	
EndProcedure

Runtime Procedure OnClickAttribDel()               ;delete an user defined attribute
	Protected a$, b$, i, j, GoOn, *node
	
	i = GetGadgetState(DID("tree_objects"))
	j = GetGadgetState(DialogGadget(#Dialog_UserAttr, "userattribs"))
	If i > -1 And j > -1
		*node = GetGadgetItemData(DID("tree_objects"), i)
		a$    = GetGadgetItemText(DialogGadget(#Dialog_UserAttr, "userattribs"), j)
		RemoveXMLAttribute(*node, "_" + a$)
		RemoveGadgetItem(DialogGadget(#Dialog_UserAttr, "userattribs"), j)
		SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_name"), "")
		SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_value"), "")
		DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_name"), 1)
		DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_value"), 1)
	EndIf
		
EndProcedure

Runtime Procedure OnUserAttribChange()             ;selected item in the user defined attribute listview changed
	Protected i, j, a$, *node
	
	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*node = GetGadgetItemData(DID("tree_objects"), i)
		j = GetGadgetState(DialogGadget(#Dialog_UserAttr, "userattribs"))
		If j > -1
			a$ = GetGadgetItemText(DialogGadget(#Dialog_UserAttr, "userattribs"), j)
			SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_name"), a$)
			SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_value"), GetXMLAttribute(*node, "_" + a$))
			DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_del"), 0)
			DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_name"), 0)
			DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_value"), 0)
		EndIf
	Else
		DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_name"), 1)
		DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_value"), 1)
	EndIf
	
EndProcedure

                                                     ;this is to make sure the window doesn't try to open on a no longer available second desktop
Procedure CheckWindowXY(*x.INTEGER, *y.INTEGER, *w.INTEGER, *h.INTEGER, minWidth, minHeight)
	Protected i, j, maxX, maxY, minX, minY
	
	;first find the min/max dimensions of all enabled desktops 
	j = ExamineDesktops()
	For i = 0 To j - 1
		If DesktopX(i) < minX
			minX = DesktopX(i)
		EndIf
		If DesktopX(i) + DesktopWidth(i) > maxX
			maxX = DesktopX(i) + DesktopWidth(i)
		EndIf
		If DesktopY(i) < minY
			minY = DesktopY(i)
		EndIf
		If DesktopY(i) + DesktopHeight(i) > maxY
			maxY = DesktopY(i) + DesktopHeight(i)
		EndIf
	Next i
	
	;next, check if this window will fit inside the desktop(s), if not change the coordinates
	;first on the x axis
	If *w\i < minWidth
		;this window is smaller than allowed, we set w to the minimum width
		*w\i = minWidth
	EndIf
	If *x\i < minX
		;the left edge is outside of our desktop(s), we use the very left point as new x value.
		*x\i = minX
	EndIf
	If *w\i > maxX - minX
		;the width is bigger then the whole desktop environment, we set it to minWidth and the x position to the left edge of the desktop
		*w\i = minWidth
		*x\i = minX
	ElseIf *x\i + *w\i > maxX
		;the right edge of the window is outside the desktop(s), we move the window completely to the right
		*x\i = maxX - *w\i
	EndIf
	
	;next on the y axis
	If *h\i < minHeight
		;this window is not high enough, we use minHeight instead as h
		*h\i = minHeight
	EndIf
	If *y\i < minY
		;the top of the window is above our desktop(s), we use the top edge of our desktop(s) instead
		*y\i = minY
	EndIf
	If *h\i > maxY - minY
		;the height is bigger then the overall height of the desktop(s), we set it to minHeight and the y position to the top edge of the desktop
		*h\i = minHeight
		*y\i = minY
	ElseIf *y\i + *h\i > maxY
		;the bottom of the window will be below the bottom of our desktop(s), we move it higher (not taking taskbar size into account!)
		*y\i = maxY - *h\i
	EndIf
	
EndProcedure

Runtime Procedure OnUserAttributes()               ;user clicked on the user attributes button, show additional window
	Protected *node, i, a$, x, y, w, h
	
	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*node = GetGadgetItemData(DID("tree_objects"), i)
		If XMLNodeType(*node) = #PB_XML_Normal
			ClearGadgetItems(DialogGadget(#Dialog_UserAttr, "userattribs"))
			SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_name"), "")
			SetGadgetText(DialogGadget(#Dialog_UserAttr, "attrib_value"), "")
			DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_del"), 1)
			DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_name"), 1)
			DisableGadget(DialogGadget(#Dialog_UserAttr, "attrib_value"), 1)
			If ExamineXMLAttributes(*node)
				While NextXMLAttribute(*node)
					a$ = XMLAttributeName(*node)
					If Left(a$, 1) = "_"
						Select a$
							Case "_id", "_name", "_onevent", "_onchange", "_onfocus", "_onlostfocus", "_ondragstart", "_onrightclick", "_onleftclick", "_onrightdoubleclick", "_onleftdoubleclick"
								;ignore
							Default
								AddGadgetItem(DialogGadget(#Dialog_UserAttr, "userattribs"), -1, Mid(a$, 2))
						EndSelect
					EndIf
				Wend
			EndIf
			HideWindow(DialogWindow(#Dialog_UserAttr), 0)
			x = WindowX(DialogWindow(#Dialog_UserAttr))
			y = WindowY(DialogWindow(#Dialog_UserAttr))
			w = WindowWidth(DialogWindow(#Dialog_UserAttr))
			h = WindowHeight(DialogWindow(#Dialog_UserAttr))
			CheckWindowXY(@x, @y, @w, @h, 400, 200)
			ResizeWindow(DialogWindow(#Dialog_UserAttr), x, y, w, h)
			
		EndIf
	EndIf
		
EndProcedure

Runtime Procedure OnCheckBoxChanged()              ;checkbox value changed, set attributes accordingly
	Protected *node, i
	
	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*node = GetGadgetItemData(DID("tree_objects"), i)
		If GetGadgetState(DID("invisible"))
			SetXMLAttribute(*node, "invisible", "yes")
		Else
			RemoveXMLAttribute(*node, "invisible")
		EndIf
		If GetGadgetState(DID("disabled"))
			SetXMLAttribute(*node, "disabled", "yes")
		Else
			RemoveXMLAttribute(*node, "disabled")
		EndIf
		UpdateDialog(*node)
		
	EndIf
EndProcedure

Runtime Procedure OnTreeClick()                    ;user clicked on a tree gadget (NOT main tree!, this is OnObjectTreeClick()!)
	Protected *node, Gadget, Name.s, a$, b$, i, j, Search$, Replace$
	
	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*node  = GetGadgetItemData(DID("tree_objects"), i)
		Gadget = EventGadget()
		If Gadget = DID("flags")
			
			
			If GetGadgetState(DialogGadget(#Dialog_Main, "definition")) > 0
				Name     = GetXMLNodeName(*node)
				Search$  = DD(Name)\FlagsNew
				Replace$ = DD(Name)\FlagsOrig
			EndIf
			
			a$    = ""
			For i = 0 To CountGadgetItems(DID("flags")) - 1
				If GetGadgetItemState(DID("flags"), i) & #PB_Tree_Checked
					b$ = GetGadgetItemText(DID("flags"), i)
					If Name
						For j = 0 To CountString(Search$, "|")
							If StringField(Search$, j + 1, "|") = b$
								b$ = StringField(Replace$, j + 1, "|")
								Break
							EndIf
						Next j
					EndIf
					If a$ = ""
						a$ = b$
					Else
						a$ + " | " + b$
					EndIf
				EndIf
			Next i
			If a$
				SetXMLAttribute(*node, "flags", a$)
			Else
				RemoveXMLAttribute(*node, "flags")
			EndIf
		ElseIf Gadget = DID("alignsingle")
			a$ = ""
			For j = 0 To CountGadgetItems(DID("alignsingle")) - 1
				If GetGadgetItemState(DID("alignsingle"), j) & #PB_Tree_Checked
					If a$ = ""
						a$ = GetGadgetItemText(DID("alignsingle"), j)
					Else
						a$ + "," + GetGadgetItemText(DID("alignsingle"), j)
					EndIf
				EndIf
			Next j
			If a$
				SetXMLAttribute(*node, "align", a$)
			Else
				RemoveXMLAttribute(*node, "align")
			EndIf
			
		EndIf
		UpdateDialog(*node)
		
	EndIf
EndProcedure

Runtime Procedure OnComboBoxChanged()              ;combo box state changed
	Protected *node, a$, Key.s, i, Selected, Gadget

	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*node    = GetGadgetItemData(DID("tree_objects"), i)
		Gadget   = EventGadget()
		Selected = GetGadgetState(Gadget)
		a$       = GetGadgetText(Gadget)
		ForEach DID()
			If DID() = Gadget
				Key = MapKey(DID())
				Select Key
					Case "alignbox"
						Key = "align"
					Case "onevents"
						SetGadgetText(DID("onevent_proc"), StringField(a$, 2, ":"))
						ProcedureReturn 0
					Case "expandbox"
						Key = "expand"
						If Selected = 1
							DisableGadget(DID("alignbox"), 0)
							SetXMLAttribute(*node, "align", GetGadgetText(DID("alignbox")))
						Else
							DisableGadget(DID("alignbox"), 1)
							RemoveXMLAttribute(*node, "align")
							SetGadgetState(DID("alignbox"), -1)
						EndIf
						If Selected = 3
							DisableGadget(DID("expandboxitem"), 0)
							a$ + GetGadgetText(DID("expandboxitem"))
						Else
							DisableGadget(DID("expandboxitem"), 1)
						EndIf
						If Selected = 0
							;standard
							RemoveXMLAttribute(*node, "expand")
							Key = ""
						EndIf
					Case "colexpand", "rowexpand"
						If Selected = 3
							DisableGadget(DID(Key + "item"), 0)
							a$ + GetGadgetText(DID(Key + "item"))
						Else
							DisableGadget(DID(Key + "item"), 1)
						EndIf
					Case "margincombo"
						If Selected = -1
							;user entered a value
							DisableGadget(DID("marginext"), 1)
							SetXMLAttribute(*node, "margin", a$)
						Else
							DisableGadget(DID("marginext"), 0)
							SetGadgetText(DID("marginext"), StringField(GetGadgetItemText(DID("margincombo"), Selected), 2, ":"))
						EndIf
						ProcedureReturn 0
					Case "expandsingle"
						Key = "expand"
						If a$ = "yes"
							DisableGadget(DID("alignsingle"), 1)
						Else
							DisableGadget(DID("alignsingle"), 0)
						EndIf
					Case "scrolling"
						If a$ = "both"
							RemoveXMLAttribute(*node, "scrolling")
							Break
						EndIf
						
				EndSelect
				If Key
					SetXMLAttribute(*node, Key, a$)
				EndIf
				Break
			EndIf
		Next
		UpdateDialog(*node)
	EndIf
	
EndProcedure

Runtime Procedure OnRefreshDelay()                 ;trackbar (dialog delay time) changed
	Protected i
	
	i            = GetGadgetState(DID("refreshdelay"))
	RefreshDelay = 500 * i
	SetGadgetText(DID("refreshtime"), Str(RefreshDelay) + " ms")
	
EndProcedure

Procedure IsParent(*From, *To)											 ;check if *From is parent of *To
	Protected Result, *Parent
	
	If *To = *From
		Result = #True
	Else
		Repeat
			*To = ParentXMLNode(*To)
			If *To = *From
				Result = #True
				Break
			EndIf
		Until *To <> 0
	EndIf
	
	ProcedureReturn Result
EndProcedure

                                                     ;not all combinations are allowed, we try to find out if the node under the mouse cursor is o.k. or not
Procedure CheckIfNodeIsAvailable(*NodeFrom, IndexTo, Mode)
	Protected *Node, *Parent, *Temp, Name.s, a$, MovedType, ParentType.s, GoOn, Result, MaxChilds, UsableChilds
	
	*Node = GetGadgetItemData(DID("tree_objects"), IndexTo)
	If XMLNodeType(*Node) = #PB_XML_Normal
		Name         = GetXMLNodeName(*Node)
		a$           = GetXMLNodeName(*NodeFrom)
		MovedType    = DD(a$)\Type
		*Parent      = ParentXMLNode(*NodeFrom)
		If *Parent
			ParentType = GetXMLNodeName(*Parent)
		EndIf
		If Name <> "dialogs" And *Node <> *NodeFrom And (Mode = #PB_Drag_Copy	Or IsParent(*NodeFrom, *Node) = 0);*Node <> *Parent ;AND Name <> "window"
			GoOn = #True
			If Mode = #PB_Drag_Move
				If ParentType = "window"
					;be careful, if we move the child of a window inside the same window, the whole childs will be no longer reachable!
					;so make sure, that our new position is not inside the same window!
					*Temp = *Node
					While GetXMLNodeName(*Temp) <> "window"
						*Temp = ParentXMLNode(*Temp)
					Wend
					If *Temp = *Parent
						;moving to same window is NOT allowed!
						GoOn = #False
					EndIf
				EndIf
			EndIf
			If GoOn
				If MovedType = #DialogType_Tab
					If Name = "panel" And (*Parent <> *Node Or Mode = #PB_Drag_Copy)
						Result = #True
					EndIf
				Else
					MaxChilds    = DD(Name)\MaxChilds
					UsableChilds = DD(Name)\UsableChilds
					If (UsableChilds = -1 Or MovedType = UsableChilds) And (MaxChilds = -1 Or MaxChilds > MyXMLChildCount(*Node))
						Result = #True
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	
	ProcedureReturn Result
EndProcedure

                                                     ;Dis/Enable menu items
Procedure DisableMenuItems(AddWindow, MoveChildUp, MoveChildDown, AddChilds, AddContainer, Delete, UsableChilds, Comments, Copy, Paste, SwitchContainers)
	Protected i
	
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_AddWindow, AddWindow)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_LoadAdditionalDialoge, AddWindow)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_MoveChildUp, MoveChildUp)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_MoveChildDown, MoveChildDown)
	DisableGadget(DialogGadget(#Dialog_Main, "move_up"), MoveChildUp)
	DisableGadget(DialogGadget(#Dialog_Main, "move_down"), MoveChildDown)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_Delete, Delete)
	
	For i = #DialogType_Button To #DialogType_Web
		If AddChilds = 1
			DisableMenuItem(#Popup_Menu_Tree, i, AddChilds)
		ElseIf UsableChilds = -1
			If i = #DialogType_Tab
				DisableMenuItem(#Popup_Menu_Tree, i, 1)
			Else
				DisableMenuItem(#Popup_Menu_Tree, i, AddChilds)
			EndIf
		ElseIf i = UsableChilds
			DisableMenuItem(#Popup_Menu_Tree, i, 0)
		Else
			DisableMenuItem(#Popup_Menu_Tree, i, 1)
		EndIf
	Next i
	If SubMenuHandles(#SubMenu_AddChilds)
		DisableMenuItem(#Popup_Menu_Tree, SubMenuHandles(#SubMenu_AddChilds),          AddChilds)
		DisableMenuItem(#Popup_Menu_Tree, SubMenuHandles(#SubMenu_AddMultiContainer),  AddContainer)
		DisableMenuItem(#Popup_Menu_Tree, SubMenuHandles(#SubMenu_AddSingleContainer), AddContainer)
	EndIf
	
	For i = #DialogType_HBox To #DialogType_SingleBox
		DisableMenuItem(#Popup_Menu_Tree, i, AddContainer)
	Next i
	
	ForEach UnsupportedItems()
		DisableMenuItem(#Popup_Menu_Tree, UnsupportedItems(), 1)
	Next
	
	
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_AddComment, Comments)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_Copy, Copy)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_Cut, Copy)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_Paste, Paste)
	DisableMenuItem(#Popup_Menu_Tree, #TreeMenu_SwitchContainer, SwitchContainers)
	
EndProcedure

Procedure CheckMenuItems(CheckItem = #Check_Nothing) ;make sure, that only allowed menu items are enabled
	Protected *Node, *First, *Parent, i, MoveUp, MoveDn, AddItems, AddContainer, Paste, Count, Copy, Delete, SwitchContainer, Result

	*Node = SelectDDFromTree()
	If *Node
		If XMLNodeType(*Node) = #PB_XML_Comment
			MoveDn  = 1
			Copy    = 1
			Paste   = 1
			*Parent = ParentXMLNode(*Node)
			*First  = ChildXMLNode(*Parent, 1)
			If *Node = *First
				MoveUp = 1
			EndIf
			If NextXMLNode(*Node)
				MoveDn = 0
			EndIf
			DisableMenuItems(1, MoveUp, MoveDn, 1, 1, Delete, 1, 1, Copy, Paste, 1)
		Else
			Count = MyXMLChildCount(*Node)
			If DD()\Type = #DialogType_Dialogs
				Copy   = 1
				Paste  = 1
				Delete = 1
				DisableMenuItems(0, 1, 1, 1, 1, Delete, DD()\UsableChilds, 1, Copy, Paste, 1)
			Else
				MoveDn   = 1
				If DD()\MaxChilds > -1 And Count >= DD()\MaxChilds
					;no more childs possible!
					AddItems = 1
				EndIf
				*Parent = ParentXMLNode(*Node)
				*First  = ChildXMLNode(*Parent, 1)
				If *Node = *First
					MoveUp = 1
				EndIf
				If NextXMLNode(*Node)
					MoveDn = 0
				EndIf

				If AddItems = 1
					Paste = 1
				ElseIf *CopyNode
					Paste = 0
				ElseIf Cut\Node
					Paste = 1
					i     = GetGadgetState(DID("tree_objects"))
					If i > -1
						If CheckIfNodeIsAvailable(Cut\Node, i, #PB_Drag_Move)
							Paste = 0
						EndIf
					EndIf
				Else
					Paste = 1
				EndIf
				SwitchContainer = 1
				Copy = 0
				If DD()\Type = #DialogType_Window
					Copy = 1
				EndIf
				AddContainer = AddItems
				Select DD()\Type
					Case #DialogType_SingleBox, #DialogType_Container, #DialogType_Frame, #DialogType_ScrollArea, #DialogType_VBox, #DialogType_HBox, #DialogType_GridBox, #DialogType_MultiBox
						SwitchContainer = 0
					Case #DialogType_Panel
						AddContainer = 1
				EndSelect
				DisableMenuItems(1, MoveUp, MoveDn, AddItems, AddContainer, Delete, DD()\UsableChilds, 0, Copy, Paste, SwitchContainer)
			EndIf
		EndIf
		
		Select CheckItem
			Case #Check_Copy
				Result = 1 - Copy
			Case #Check_Delete
				Result = 1 - Delete
			Case #Check_Paste
				Result = 1 - Paste
		EndSelect
	EndIf
	
	ProcedureReturn Result
EndProcedure

Runtime Procedure OnObjectTreeRClick()             ;user clicked on ObjectTree via right mouse button, show popup  menu
	
	CheckMenuItems()
	DisplayPopupMenu(#Popup_Menu_Tree, WindowID(DialogWindow(#Dialog_Main)))
	
EndProcedure

Runtime Procedure OnObjectTreeClick()              ;new item selected, set all gadgets accordingly
	Protected *node, *parent, Name.s, a$, b$, c$, d$, i, j, k, Box
	Protected ExpandFound, SpacingFound
	
	ClearTexts()
	i = GetGadgetState(DID("tree_objects"))
	If i = -1
		DisableAll(1)
	Else
		*node = GetGadgetItemData(DID("tree_objects"), i)
		ItemSelect(*node)
		If XMLNodeType(*node) = #PB_XML_Comment
			DisableAll(1)
			SetGadgetText(DialogGadget(#Dialog_Main, "comment"), GetXMLNodeText(*node))
			HideGadget(DialogGadget(#Dialog_Main, "container_comment"), 0)
; 			RefreshDialog(#Dialog_Main)
			CheckMenuItems()
			PostEvent(#Event_RefreshMainWindow, DialogWindow(#Dialog_Main), 0)
			ProcedureReturn 0
		EndIf
		CheckPanel(*node)
		DisableAll(0)
		Name  = GetXMLNodeName(*node)
		If LCase(Name) = "dialogs"
			;clear all data
			DisableAll(1)
			HideGadget(DialogGadget(#Dialog_Main, "container_dialog"), 0)
		Else
			*parent = ParentXMLNode(*node)
			If *parent And XMLNodeType(*parent) = #PB_XML_Normal And LCase(GetXMLNodeName(*parent)) = "gridbox"
				DisableGadget(DID("colspan"), 0)
				DisableGadget(DID("rowspan"), 0)
			Else
				DisableGadget(DID("colspan"), 1)
				DisableGadget(DID("rowspan"), 1)
			EndIf
			Name = LCase(Name)
			If FindMapElement(DD(), Name)
				ClearGadgetItems(DID("flags"))
				If GetGadgetState(DialogGadget(#Dialog_Main, "definition")) > 0
					If DD()\FlagsNew
						For i = 0 To CountString(DD()\FlagsNew, "|")
							AddGadgetItem(DID("flags"), -1, Trim(StringField(DD()\FlagsNew, i + 1, "|")))
						Next i
					EndIf
				Else
					If DD()\PossibleFlags
						For i = 0 To CountString(DD()\PossibleFlags, "|")
							AddGadgetItem(DID("flags"), -1, Trim(StringField(DD()\PossibleFlags, i + 1, "|")))
						Next i
					EndIf
				EndIf
				
				Select DD()\Type
					Case #DialogType_Window
						HideGadget(DialogGadget(#Dialog_Main, "container_window"), 0)
					Case #DialogType_GridBox
						HideGadget(DialogGadget(#Dialog_Main, "container_gridbox"), 0)
					Case #DialogType_HBox, #DialogType_VBox
						Box = #True
						HideGadget(DialogGadget(#Dialog_Main, "container_boxes"), 0)
					Case #DialogType_MultiBox
						HideGadget(DialogGadget(#Dialog_Main, "container_multibox"), 0)
					Case #DialogType_SingleBox
						HideGadget(DialogGadget(#Dialog_Main, "container_singlebox"), 0)
						DisableGadget(DID("marginext"), 1)
					Case #DialogType_Splitter
						HideGadget(DialogGadget(#Dialog_Main, "container_splitter"), 0)
					Case #DialogType_ScrollArea
						HideGadget(DialogGadget(#Dialog_Main, "container_scrollarea"), 0)
					Case #DialogType_Tab
						M_CloseSelectionWindows
				EndSelect
				DisableGadget(DID("group"), 1 - DD()\GroupSupport)
				DisableGadget(DID("value"), 1 - DD()\ValueSupport)
				DisableGadget(DID("min"),   1 - DD()\MinSupport)
				DisableGadget(DID("max"),   1 - DD()\MaxSupport)
				DisableGadget(DID("page"),  1 - DD()\PageSupport)
				ClearGadgetItems(DID("onevents"))
				If DD()\PossibleEvents And NoRuntimeEvents = 0
					DisableGadget(DID("onevents"), 0)
					DisableGadget(DID("onevent_proc"), 0)
					For i = 0 To CountString(DD()\PossibleEvents, ",")
						AddGadgetItem(DID("onevents"), -1, StringField(DD()\PossibleEvents, i + 1, ","))
					Next i
				Else
					DisableGadget(DID("onevents"), 1)
					DisableGadget(DID("onevent_proc"), 1)
				EndIf
				ResetMarginCombo()
				If ExamineXMLAttributes(*node)
					While NextXMLAttribute(*node)
						a$ = LCase(XMLAttributeName(*node))
						b$ = XMLAttributeValue(*node)
						c$ = LCase(b$)
						Select a$
							Case "invisible", "disabled"
								If c$ = "yes"
									SetGadgetState(DID(a$), 1)
								EndIf
							Case "flags"
								;handle flags
								If GetGadgetState(DialogGadget(#Dialog_Main, "definition")) > 0
									For i = 0 To CountString(b$, "|")
										For j = 0 To CountString(DD()\FlagsOrig, "|")
											If Trim(StringField(b$, i + 1, "|")) = StringField(DD()\FlagsOrig, j + 1, "|")
												d$ = StringField(DD()\FlagsNew, j + 1, "|")
												For k = 0 To CountGadgetItems(DID("flags")) - 1
													If GetGadgetItemText(DID("flags"), k) = d$
														SetGadgetItemState(DID("flags"), k, #PB_Tree_Checked)
														Break 2
													EndIf
												Next k
											EndIf
										Next j
									Next i
								Else
									For i = 0 To CountString(b$, "|")
										For j = 0 To CountGadgetItems(DID("flags")) - 1
											If LCase(GetGadgetItemText(DID("flags"), j)) = Trim(StringField(c$, i + 1, "|"))
												SetGadgetItemState(DID("flags"), j, #PB_Tree_Checked)
												Break
											EndIf
										Next j
									Next i
								EndIf
							Case "align"
								If Box
									If c$ = "center"
										SetGadgetState(DID("alignbox"), 1)
									ElseIf c$ = "bottom/right"
										SetGadgetState(DID("alignbox"), 2)
									ElseIf c$ = "top/left"
										SetGadgetState(DID("alignbox"), 0)
									EndIf
									If GetGadgetState(DID("expandbox")) = 1
										DisableGadget(DID("alignbox"), 0)
									Else
										DisableGadget(DID("alignbox"), 1)
									EndIf
								Else
									;singlebox
									For i = 0 To CountString(b$, ",")
										For j = 0 To CountGadgetItems(DID("alignsingle")) - 1
											If LCase(GetGadgetItemText(DID("alignsingle"), j)) = Trim(StringField(c$, i + 1, ","))
												SetGadgetItemState(DID("alignsingle"), j, #PB_Tree_Checked)
												Break
											EndIf
										Next j
									Next i
									If GetGadgetState(DID("expandsingle")) > 0
										DisableGadget(DID("alignsingle"), 0)
									Else
										DisableGadget(DID("alignsingle"), 1)
									EndIf
								EndIf
								
							Case "expand"
								;check if it is a singlebox or hbox or vbox
								ExpandFound = #True
								If Box
									DisableGadget(DID("alignbox"), 1)
									DisableGadget(DID("expandboxitem"), 1)
									If c$ = "yes"
										SetGadgetState(DID("expandbox"), 0)
										RemoveXMLAttribute(*node, "expand")
									ElseIf c$ = "no"
										SetGadgetState(DID("expandbox"), 1)
										DisableGadget(DID("alignbox"), 0)
									ElseIf c$ = "equal"
										SetGadgetState(DID("expandbox"), 2)
									ElseIf Left(c$, 4) = "item" And FindString(b$, ":")
										SetGadgetState(DID("expandbox"), 3)
										SetGadgetText(DID("expandboxitem"), Trim(StringField(c$, 2, ":")))
										DisableGadget(DID("expandboxitem"), 0)
									Else
										SetGadgetState(DID("expandbox"), -1)
									EndIf
								Else
									DisableGadget(DID("alignsingle"), 0)
									If c$ = "yes"
										DisableGadget(DID("alignsingle"), 1)
										SetGadgetState(DID("expandsingle"), 0)
										RemoveXMLAttribute(*node, "expand")
									ElseIf c$ = "no"
										SetGadgetState(DID("expandsingle"), 1)
									ElseIf c$ = "vertical"
										SetGadgetState(DID("expandsingle"), 2)
									ElseIf c$ = "horizontal"
										SetGadgetState(DID("expandsingle"), 3)
									Else
										SetGadgetState(DID("expandsingle"), -1)
										DisableGadget(DID("alignsingle"), 1)
									EndIf
								EndIf

							Case "colexpand", "rowexpand"
								;combo box!
								DisableGadget(DID(a$ + "item"), 1)
								If c$ = "yes"
									SetGadgetState(DID(a$), 0)
								ElseIf c$ = "no"
									SetGadgetState(DID(a$), 1)
								ElseIf c$ = "equal"
									SetGadgetState(DID(a$), 2)
								ElseIf Left(c$, 4) = "item" And FindString(b$, ":")
									SetGadgetState(DID(a$), 3)
									DisableGadget(DID(a$ + "item"), 0)
									SetGadgetText(DID(a$ + "item"), StringField(Trim(b$), 2, ":"))
								Else
									SetGadgetState(DID(a$), -1)
								EndIf
							Case "margin"
								;combobox!
								If Str(Val(c$)) = c$
									;this is just a number!
									SetGadgetText(DID("margincombo"), c$)
									DisableGadget(DID("marginext"), 1)
								Else
									For i = 0 To CountGadgetItems(DID("margincombo")) - 1
										For j = 0 To CountString(c$, ",")
											If FindString(StringField(c$, j + 1, ","), GetGadgetItemText(DID("margincombo"), i))
												SetGadgetItemText(DID("margincombo"), i, StringField(c$, j + 1, ","))
												Break
											EndIf
										Next j
									Next i
									SetGadgetState(DID("margincombo"), 0)
									SetGadgetText(DID("marginext"), StringField(GetGadgetText(DID("margincombo")), 2, ":"))
									DisableGadget(DID("marginext"), 0)
								EndIf
											
							Case "minwidth", "minheight", "minheight", "maxwidth"
								If c$ = "auto"
									SetGadgetText(DID(a$), "")
								Else
									SetGadgetText(DID(a$), b$)
								EndIf
							Case "_onevent", "_onchange", "_onfocus", "_onlostfocus", "_ondragstart", "_onrightclick", "_onleftclick", "_onrightdoubleclick", "_onleftdoubleclick"
								For i = 0 To CountGadgetItems(DID("onevents")) - 1
									If GetGadgetItemText(DID("onevents"), i) = Mid(a$, 2)
										SetGadgetItemText(DID("onevents"), i, Mid(a$, 2) + ":" + b$)
										If GetGadgetState(DID("onevents")) = -1
											SetGadgetState(DID("onevents"), i)
											SetGadgetText(DID("onevent_proc"), b$)
										EndIf
										Break
									EndIf
								Next i
							Case "scrolling"
								For i = 0 To CountGadgetItems(DID("scrolling")) - 1
									If GetGadgetItemText(DID("scrolling"), i) = b$
										SetGadgetState(DID("scrolling"), i)
										Break
									EndIf
								Next i
							Default
								If FindMapElement(DID(), a$) ;<- to make sure this is no unsupported attribute
									SetGadgetText(DID(a$), b$)
								EndIf
								If a$ = "spacing"
									SpacingFound = #True
								EndIf
						EndSelect
					Wend
					If ExpandFound = 0
						If Box
							SetGadgetState(DID("expandbox"), 0)
							DisableGadget(DID("alignbox"), 1)
							DisableGadget(DID("expandboxitem"), 1)
						Else
							SetGadgetState(DID("expandsingle"), 0)
							DisableGadget(DID("alignsingle"), 1)
						EndIf
					EndIf
					If SpacingFound = 0
						SetGadgetText(DID("spacing"), "5")
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	CheckMenuItems()
	;ItemSelect(*node)
	PostEvent(#Event_RefreshMainWindow, DialogWindow(#Dialog_Main), 0)
; 	RefreshDialog(#Dialog_Main)
EndProcedure

Procedure RefreshMainDialog()                       ;sometimes dialog items will not be correctly redrawn, it helps, if we do the refreshdialog at the end of the queue (but not always!)
	RefreshDialog(#Dialog_Main)
EndProcedure

Procedure BuildUpTree(*node = 0, TreePos = 0)       ;rebuild the whole ObjectTree
	Protected Name.s, IsTab, Attr.s, b$, i, OnlyRefresh = #True
	Protected *Parent, Count, *Last ;xml fix
	NewMap Expanded.i()
	
	If *node = 0
		*node = RootXMLNode(#XML_Loaded)
		If OnlyRefresh
			Count = CountGadgetItems(DID("tree_objects")) - 1
			For i = 0 To Count
				Expanded(Str(GetGadgetItemData(DID("tree_objects"), i))) = GetGadgetItemState(DID("tree_objects"), i) & #PB_Tree_Expanded
			Next i
			If MapSize(Expanded()) <= 1
				OnlyRefresh = 0
			EndIf
		EndIf
		CompilerIf #PB_Compiler_OS = #PB_OS_Linux And Subsystem("qt")
			SetGadgetState(DID("tree_objects"), -1)
		CompilerEndIf
		
		ClearGadgetItems(DID("tree_objects"))
		If *node
			*node = MainXMLNode(#XML_Loaded)
			If *node
				BuildUpTree(*node)
				Count = CountGadgetItems(DID("tree_objects")) - 1
				For i = 0 To Count
					If OnlyRefresh = 0 Or FindMapElement(Expanded(), Str(GetGadgetItemData(DID("tree_objects"), i))) = 0 Or Expanded()
						SetGadgetItemState(DID("tree_objects"), i, #PB_Tree_Expanded)
					EndIf
				Next i
			EndIf
		EndIf
		RefreshDialog(#Dialog_Main)
		ProcedureReturn 0
	EndIf
	
	Count = CountGadgetItems(DID("tree_objects"))
	Select XMLNodeType(*node)

		Case #PB_XML_Normal
			
			Name = GetXMLNodeName(*node)
			b$   = Name
			If Name = "tab"
				IsTab = #True
			EndIf
			If DD(b$)\AltName
				Name = DD(b$)\AltName
			EndIf
			
			If IsTab
				Attr = GetXMLAttribute(*node, "text")
				If Attr
					Name + " (" + Attr + ")"
				EndIf
			Else
				Attr = GetXMLAttribute(*node, "_name")
				If Attr
					Name + " (" + Attr + ")"
				Else
					Attr = GetXMLAttribute(*node, "_id")
					If Attr
						Name + " (id: " + Attr + ")"
					EndIf
				EndIf
			EndIf
			If DD(b$)\ImageID
				AddGadgetItem(DID("tree_objects"), -1, Name, ImageID(DD(b$)\ImageID), TreePos)
			Else
				AddGadgetItem(DID("tree_objects"), -1, Name, 0, TreePos)
			EndIf
			SetGadgetItemData(DID("tree_objects"), Count, *node)
		Case #PB_XML_Comment
			Name = GetXMLNodeText(*node)
			If Len(Name) > Val(GetGadgetText(DID("max_chars")))
				Name = Left(Name, Val(GetGadgetText(DID("max_chars")))) + "..."
			EndIf
			AddGadgetItem(DID("tree_objects"), -1, "<!-- " + Name + " -->", ImageID(#Image_Comments), TreePos)
			SetGadgetItemData(DID("tree_objects"), Count, *node)
			If GetGadgetState(DID("enable_color"))
				SetGadgetItemColor(DID("tree_objects"), Count, #PB_Gadget_FrontColor, CommentColor)
			EndIf
		Case #PB_XML_CData, #PB_XML_DTD, #PB_XML_Instruction
 			;ignore
	EndSelect
	
	For i = 1 To XMLChildCount(*node)
		BuildUpTree(ChildXMLNode(*node, i), TreePos + 1)
	Next i
	
EndProcedure

Procedure ExpandAll()                               ;after redo/undo the tree will be in an unknown state, this procedure will expand all items.
	Protected i, Size
	
	Size = CountGadgetItems(DID("tree_objects")) - 1
	For i = 0 To Size
		SetGadgetItemState(DID("tree_objects"), i, #PB_Tree_Expanded)
	Next i
EndProcedure

Runtime Procedure Undo_Do()                        ;Undo last step
	
	If PreviousElement(*Undo())
		If CatchXML(#XML_Loaded, *Undo(), MemorySize(*Undo()))
			BuildUpTree()
			ExpandAll()
			ForEach OpenDialogs()
				If IsDialog(OpenDialogs()\DialogID)
					FreeDialog(OpenDialogs()\DialogID)
				EndIf
			Next
			ClearList(OpenDialogs())
			ShowAllDialogs()
			DisableGadget(DialogGadget(#Dialog_Main, "redo"), 0)
			UndoRedoPossible = #Redo_Possible | #Undo_Possible
			ForEach OpenDialogs()
				OpenDialogs()\UpdateTimeOUT = ElapsedMilliseconds()
			Next
			PushListPosition(*Undo())
			If PreviousElement(*Undo()) = 0
				DisableGadget(DialogGadget(#Dialog_Main, "undo"), 1)
				UndoRedoPossible = #Redo_Possible
			EndIf
			PopListPosition(*Undo())
			ClearTexts()
		EndIf
	EndIf
EndProcedure

Runtime Procedure Undo_ReDo()                      ;Redo last step
	
	If NextElement(*Undo())
		If CatchXML(#XML_Loaded, *Undo(), MemorySize(*Undo()))
			BuildUpTree()
			ExpandAll()
			ForEach OpenDialogs()
				If IsDialog(OpenDialogs()\DialogID)
					FreeDialog(OpenDialogs()\DialogID)
; 					CloseWindow(OpenDialogs()\WindowID)
				EndIf
			Next
			ClearList(OpenDialogs())
			ShowAllDialogs()
			UndoRedoPossible = #Undo_Possible | #Redo_Possible
			DisableGadget(DialogGadget(#Dialog_Main, "undo"), 0)
			ForEach OpenDialogs()
				OpenDialogs()\UpdateTimeOUT = ElapsedMilliseconds()
			Next
			PushListPosition(*Undo())
			If NextElement(*Undo()) = 0
				DisableGadget(DialogGadget(#Dialog_Main, "redo"), 1)
				UndoRedoPossible = #Undo_Possible
			EndIf
			PopListPosition(*Undo())
			ClearTexts()
		EndIf
	EndIf

EndProcedure

Procedure OnShortCut_Undo()
	If UndoRedoPossible & #Undo_Possible
		Undo_Do()
	EndIf
EndProcedure

Procedure OnShortCut_Redo()
	If UndoRedoPossible & #Redo_Possible
		Undo_ReDo()
	EndIf
EndProcedure

Runtime Procedure OnObjectTreeDrag()               ;User starts a drag&drop action, store Item in variable "DragNode"
	Protected i, *Node

	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*Node = GetGadgetItemData(DID("tree_objects"), i)
		If XMLNodeType(*Node) = #PB_XML_Normal
			*DragNode = *Node
			Select GetXMLNodeName(*DragNode)
				Case "window", "dialogs"
					;no moving supported
				Default
					DragPrivate(1, #PB_Drag_Move | #PB_Drag_Copy)
			EndSelect
		EndIf
	EndIf
EndProcedure

Procedure OnDebug()
	Protected i, *Node
	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		*Node   = GetGadgetItemData(DID("tree_objects"), i)
		If *Node
			LogIT(GetXMLAttribute(*Node, "name"))
		EndIf
	EndIf
	
EndProcedure

                                                     ;callback, while dragging. We need to find the item under the mouse. Need API unfortunately here.
Procedure DropCallback(ZielHandle, Status, Format.l, Aktion, x, y) 
	Protected i, *Node, Count 
	Static Result
	

	If Format = #PB_Drop_Private
		
		Select Status
				
			Case #PB_Drag_Enter, #PB_Drag_Leave
				Result = #True
				
			Case #PB_Drag_Update
				Count  = CountGadgetItems(DID("tree_objects"))
				i      = GetTreeItemBelowCursor(DID("tree_objects"), x, y)
				DoTreeAutoScroll(DID("tree_objects"), y, i)
				
				Result = #False
				If i >= 0 And i < Count
					Result = CheckIfNodeIsAvailable(*DragNode, i, Aktion)
				EndIf
		EndSelect
	ElseIf Format = #PB_Drop_Files
		Result      = #False
		If CountGadgetItems(DID("tree_objects")) > 0
			*Node = GetGadgetItemData(DID("tree_objects"), 0)
			If *Node And GetXMLNodeName(*Node) = "dialogs"
				Result = #True
			EndIf
		EndIf
	EndIf
	;Debug Result
	
	ProcedureReturn Result
EndProcedure

Procedure SelectTreeItem(*Node)                     ;just a stupid procedure, because I needed it quite often. Rebuild the whole ObjectTree and select the correct item afterwards
	Protected i, Count
	
	BuildUpTree()
	Count = CountGadgetItems(DID("tree_objects")) - 1
	For i = 0 To Count
		If GetGadgetItemData(DID("tree_objects"), i) = *Node
			SetGadgetState(DID("tree_objects"), i)
			Break
		EndIf
	Next i
EndProcedure

Procedure OnMenuAddComment()                        ;Add a comment
	Protected *Prev, *Parent, Index, *Node

	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		*Node   = GetGadgetItemData(DID("tree_objects"), Index)
		*Parent = ParentXMLNode(*Node)
		If *Parent
			*Node = CreateXMLNode(*Parent, "", *Node, #PB_XML_Comment)
			SelectTreeItem(*Node)
			OnObjectTreeClick()
			CheckMenuItems()
		EndIf
	EndIf
	
EndProcedure

Procedure MoveTreeItems(Index, Inc)                 ;Move Tree Items without rebuild of the whole tree
	Protected *TNode, *MNode, Sub, S, TIndex, TName.s, i, j, F, Old, Count, UseColor
	
	NewList Expanded.i()
	
	Sub    = GetGadgetItemAttribute(DID("tree_objects"), Index, #PB_Tree_SubLevel) ;store sub-level of selected index
	*MNode = GetGadgetItemData(DID("tree_objects"), Index)												 ;store *Node of selected index
	F      = #False
	;Find previous (if Inc = #False) or next (if Inc = #True) tree item
	Count = CountGadgetItems(DID("tree_objects")) - 1
	For i = 0 To Count
		If GetGadgetItemAttribute(DID("tree_objects"), i, #PB_Tree_SubLevel) = Sub   ;same sub level, so go on
			If i = Index
				If Inc = #False
					TIndex = Old
					Break
				Else
					F = #True
				EndIf
			ElseIf F
				TIndex = i
				Break
			Else
				Old = i
			EndIf
		EndIf
	Next i
	
	;Make sure, that Index < TIndex
	If TIndex < Index
		Swap TIndex, Index
	EndIf
	
	AddElement(Expanded())
	Expanded() = GetGadgetItemState(DID("tree_objects"), TIndex) & #PB_Tree_Expanded
	For i = TIndex + 1 To Count
		If GetGadgetItemAttribute(DID("tree_objects"), i, #PB_Tree_SubLevel) <= Sub
			Break
		EndIf
		AddElement(Expanded())
		Expanded() = GetGadgetItemState(DID("tree_objects"), i) & #PB_Tree_Expanded
	Next i

	i        = 0
	j        = 0
	UseColor = GetGadgetState(DID("enable_color"))
	Repeat
		*TNode = GetGadgetItemData(DID("tree_objects"), TIndex + j + i)
		TName  = GetGadgetItemText(DID("tree_objects"), TIndex + j + i)
		S      = GetGadgetItemAttribute(DID("tree_objects"), TIndex + j + i, #PB_Tree_SubLevel)
		If j > 0 And S <= Sub
			Break
		EndIf
		
		If XMLNodeType(*TNode) = #PB_XML_Comment
			AddGadgetItem(DID("tree_objects"), Index + j, TName, ImageID(#Image_Comments), S)
			If UseColor
				SetGadgetItemColor(DID("tree_objects"), Index + j, #PB_Gadget_FrontColor, CommentColor)
			EndIf
		Else
			AddGadgetItem(DID("tree_objects"), Index + j, TName, ImageID(DD(GetXMLNodeName(*TNode))\ImageID), S)
		EndIf
		SetGadgetItemData(DID("tree_objects"), Index + j, *TNode)
		j + 1
		i + 1
	Until TIndex + j + i >= CountGadgetItems(DID("tree_objects"))

	RemoveGadgetItem(DID("tree_objects"), TIndex + j)
	j = 0
	ForEach Expanded()
		SetGadgetItemState(DID("tree_objects"), Index + j, Expanded())
		j + 1
	Next
	
	If Inc = #True
		SetGadgetState(DID("tree_objects"), Index + j)
	Else
		SetGadgetState(DID("tree_objects"), Index)
	EndIf

			
EndProcedure

Procedure CopyNode(*Node)                           ;makes sure that NameCounter will be unique
	Protected i, j, a$, Count
	
	If XMLNodeType(*Node) = #PB_XML_Normal
		a$ = GetXMLAttribute(*Node, "name")
		If a$
			NameCounter + 1
			SetXMLAttribute(*Node, "name", Str(NameCounter))
			a$ = GetXMLAttribute(*Node, "_id")
			If a$
				SetXMLAttribute(*Node, "_id", a$ + "_copy" + Str(NameCounter))
			EndIf
			a$ = GetXMLAttribute(*Node, "_name")
			If a$
				SetXMLAttribute(*Node, "_name", a$ + "_copy" + Str(NameCounter))
			EndIf
		EndIf
		Count = XMLChildCount(*Node)
		For j = 1 To Count
			CopyNode(ChildXMLNode(*Node, j))
		Next j
	EndIf

EndProcedure	

Procedure OnMenuCopy()                              ;Copy Node (and all subnodes)
	Protected Index

	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		If Cut\Node
			SetGadgetItemImage(DID("tree_objects"), Cut\Index, ImageID(Cut\DD\ImageID))
			Cut\Node = 0
		EndIf
		*CopyNode = GetGadgetItemData(DID("tree_objects"), Index)
	EndIf
	
EndProcedure

Procedure OnMenuCut()                               ;Cut Node (and all subnodes)
	Protected Index

	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		If Cut\Node
			SetGadgetItemImage(DID("tree_objects"), Cut\Index, ImageID(Cut\DD\ImageID))
			Cut\Node = 0
		EndIf
		If SelectDDFromTree()
			SetGadgetItemImage(DID("tree_objects"), Index, ImageID(DD()\CutImageID))
			Cut\Index = Index
			Cut\DD    = @DD()
		EndIf
		Cut\Node  = GetGadgetItemData(DID("tree_objects"), Index)
		*CopyNode = 0
	EndIf
	
EndProcedure

Procedure OnMenuPaste()                             ;Paste Node (and all subnodes)
	Protected Index, *Node, *NewNode, i, Count
	
	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		If *CopyNode <> 0 Or Cut\Node <> 0
			*Node = GetGadgetItemData(DID("tree_objects"), Index)
			If *CopyNode
				*NewNode = CopyXMLNode(*CopyNode, *Node, -1)
				CopyNode(*NewNode)
			ElseIf Cut\Node
				MoveXMLNode(Cut\Node, *Node, -1)
				Cut\Node = 0
				Cut\Index = 0
			EndIf
			BuildUpTree()
			Count = CountGadgetItems(DID("tree_objects")) - 1
			For i = 0 To Count
				If GetGadgetItemData(DID("tree_objects"), i) = *Node
					SetGadgetState(DID("tree_objects"), i)
					Break
				EndIf
			Next i
			CheckMenuItems()
			If XMLNodeType(*Node) = #PB_XML_Normal
				UpdateDialog(*Node)
			EndIf
		EndIf
	EndIf
	
EndProcedure

Procedure SwitchContainer(Name.s)                   ;Switch existing containers
	Protected Index, *Node
	
	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		*Node = GetGadgetItemData(DID("tree_objects"), Index)
		If ExamineXMLAttributes(*Node)
			While NextXMLAttribute(*Node)
				RemoveXMLAttribute(*Node, XMLAttributeName(*Node))
			Wend
		EndIf
		SetXMLNodeName(*Node, Name)
		CheckMenuItems()
		If XMLNodeType(*Node) = #PB_XML_Normal
			UpdateDialog(*Node)
		EndIf
		BuildUpTree()
		SetGadgetState(DID("tree_objects"), Index)
		OnObjectTreeClick()
		CheckMenuItems()
	EndIf
	
EndProcedure

Procedure OnContainerSwitch()                       ;Menu Item "Switch containers" has been selected
	Protected Index, *Node, a$, i, Count
	
	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		a$    = GetGadgetItemText(DID("tree_objects"), Index)
		a$    = StringField(a$, 1, " ")
		*Node = GetGadgetItemData(DID("tree_objects"), Index)
		ClearGadgetItems(DialogGadget(#Dialog_SwitchContainer, "new_container"))
		Count = MyXMLChildCount(*Node)
		ForEach DD()
			If MapKey(DD()) <> a$ And MapKey(DD()) <> "tab" And MapKey(DD()) <> "dialogs" And MapKey(DD()) <> "window" And MapKey(DD()) <> "panel"
				Select a$
					Case "singlebox", "container", "frame", "scrollarea"
						;one child container, all is allowed!
						If DD()\MaxChilds = -1 Or DD()\MaxChilds > 0
							AddGadgetItem(DialogGadget(#Dialog_SwitchContainer, "new_container"), -1, MapKey(DD()))
						EndIf
					Case "vbox", "hbox", "gridbox", "multibox"
						If DD()\MaxChilds = -1 Or (Count <= 1 And DD()\MaxChilds > 0)
							AddGadgetItem(DialogGadget(#Dialog_SwitchContainer, "new_container"), -1, MapKey(DD()))
						EndIf
				EndSelect
			EndIf
		Next
		If CountGadgetItems(DialogGadget(#Dialog_SwitchContainer, "new_container")) > 0
			SetGadgetState(DialogGadget(#Dialog_SwitchContainer, "new_container"), 0)
			SetGadgetText(DialogGadget(#Dialog_SwitchContainer, "curr_container"), a$)
			HideWindow(DialogWindow(#Dialog_SwitchContainer), 0)
		EndIf
	EndIf
	
EndProcedure

Runtime Procedure ApplyContainerSwitch()           ;Button "Apply container switch" has been clicked
	Protected Index, *Node, a$
	
	SwitchContainer(GetGadgetText(DialogGadget(#Dialog_SwitchContainer, "new_container")))
	HideWindow(DialogWindow(#Dialog_SwitchContainer), 1)
EndProcedure

Runtime Procedure OnMenuMoveUp()                   ;user wants to move the node up within the same parent
	Protected *Prev, *Parent, Index, *Node, *N2, a$, b$

	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		*Node   = GetGadgetItemData(DID("tree_objects"), Index)
		*Parent = ParentXMLNode(*Node)
		If *Parent
			*Prev  = PreviousXMLNode(*Node)
			If *Prev
				If *Prev = ChildXMLNode(*Parent, 1)
					;this is the first one, there is a PB error, when moving to the first, so do it the other way round
					MoveXMLNode(*Prev, *Parent, *Node)
				Else
					*Prev  = PreviousXMLNode(*Prev)
					MoveXMLNode(*Node, *Parent, *Prev)
				EndIf
				;SelectTreeItem(*Node)
				MoveTreeItems(Index, 0)
				CheckMenuItems()
				If XMLNodeType(*Node) = #PB_XML_Normal
					UpdateDialog(*Node)
				EndIf
			EndIf
		EndIf
	EndIf
	
EndProcedure

Runtime Procedure OnMenuMoveDown()                 ;user wants to move the node down within the same parent
	Protected *Next, *Parent, Index, *Node, *N2, a$, Sub, i
	
	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		*Node = GetGadgetItemData(DID("tree_objects"), Index)
		*Parent = ParentXMLNode(*Node)
		If *Parent
			*Next  = NextXMLNode(*Node)
			If *Next
				MoveXMLNode(*Node, *Parent, *Next)
				;SelectTreeItem(*Node)
				MoveTreeItems(Index, #True)
				CheckMenuItems()
				If XMLNodeType(*Node) = #PB_XML_Normal
					UpdateDialog(*Node)
				EndIf
			EndIf
		EndIf
	EndIf
	
EndProcedure

Procedure OnMenuAddWindow()                         ;Add a new window and show the temporary preview already
	Protected *Node, Index, *NewNode
	
	*Node = SelectDDFromTree()
	If *Node
		Index = GetGadgetState(DID("tree_objects"))
		If DD()\Type = #DialogType_Dialogs
			NameCounter + 1
			*NewNode = CreateXMLNode(*Node, "window", -1)
			SetXMLAttribute(*NewNode, "_name", GetTempName("window"))
			SetXMLAttribute(*NewNode, "name", Str(NameCounter))
			AddElement(OpenDialogs())
			OpenDialogs()\DialogID      = CreateDialog(#PB_Any)
			OpenDialogs()\Node          = *NewNode
			OpenDialogs()\UpdateTimeOUT = 100
			SelectTreeItem(*NewNode)
			OnObjectTreeClick()
			DisableGadget(DialogGadget(#Dialog_Main, "definition"), 1)
			DisableGadget(DialogGadget(#Dialog_Main, "move_up"), 1)
			DisableGadget(DialogGadget(#Dialog_Main, "move_down"), 1)
		EndIf
	EndIf
		
EndProcedure

Procedure OnMenuAddChild()                          ;Add a child
	Protected *Node, Index, Type, *NewNode
	
	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		*Node = GetGadgetItemData(DID("tree_objects"), Index)
		Type  = EventMenu()
		ForEach DD()
			If DD()\Type = Type
				Break
			EndIf
		Next
		*NewNode = CreateXMLNode(*Node, MapKey(DD()), -1)
		Select Type
			Case #DialogType_HBox, #DialogType_MultiBox, #DialogType_Empty, #DialogType_GridBox, #DialogType_SingleBox, #DialogType_Tab, #DialogType_VBox
				;no name
			Default
				NameCounter + 1
				SetXMLAttribute(*NewNode, "_name", GetTempName(MapKey(DD())))
				SetXMLAttribute(*NewNode, "name", Str(NameCounter))
		EndSelect
		SelectTreeItem(*NewNode)
		OnObjectTreeClick()
		CheckMenuItems()
		UpdateDialog(*NewNode)
	EndIf
	
EndProcedure

Runtime Procedure ColorComments()                  ;En/Disable the color picker, depending on the "enable color" checkbox
	
	If GetGadgetState(DID("enable_color"))
		DisableGadget(DialogGadget(#Dialog_Preferences, "color_change"), 0)
		DisableGadget(DialogGadget(#Dialog_Preferences, "sel_color"), 0)
	Else
		DisableGadget(DialogGadget(#Dialog_Preferences, "color_change"), 1)
		DisableGadget(DialogGadget(#Dialog_Preferences, "sel_color"), 1)
	EndIf

EndProcedure

Runtime Procedure OnSaveAdditionalFile()           ;Set the checkboxes correctly, when user clicked on "store additional file also"
	
	If GetGadgetState(DialogGadget(#Dialog_Main, "check_storeadd"))
		DisableGadget(DialogGadget(#Dialog_Main, "check_storexml"), 0)
	Else
		DisableGadget(DialogGadget(#Dialog_Main, "check_storexml"), 1)
		SetGadgetState(DialogGadget(#Dialog_Main, "check_storexml"), 0)
	EndIf
	
EndProcedure

Procedure OnMenuDelete()                            ;Delete window/child/comment
	Protected *Node, Index, *Parent, NoUpdate, Count, Text$
	
	Index = GetGadgetState(DID("tree_objects"))
	If Index > -1
		*Node = GetGadgetItemData(DID("tree_objects"), Index)
		If XMLNodeType(*Node) = #PB_XML_Comment
			*Parent = ParentXMLNode(*Node)
			DeleteXMLNode(*Node)
			SelectTreeItem(*Parent)
			OnObjectTreeClick()
			*CopyNode = 0
			CheckMenuItems()
			Undo_Add()
			ProcedureReturn 0
		EndIf
		If GetXMLNodeName(*Node) <> "dialogs"
			Count = MyXMLChildCount(*Node)
			If Count > 0
				Text$ = ReplaceString(LAN("other")\Gadget("OL_044")\Text, "{NUM}", Str(Count))
			Else
				Text$ = LAN("other")\Gadget("OL_010")\Text
			EndIf
			If GetGadgetState(DID("conf_del")) = 0 Or MessageRequester(LAN("other")\Gadget("OL_009")\Text, Text$, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
				*Parent = ParentXMLNode(*Node)
				If GetXMLNodeName(*Node) = "window"
					ForEach OpenDialogs()
						If OpenDialogs()\Node = *Node
							CloseWindow(OpenDialogs()\WindowID)
							FreeDialog(OpenDialogs()\DialogID)
							DeleteElement(OpenDialogs())
							NoUpdate = #True
							Break
						EndIf
					Next
				EndIf
				DeleteXMLNode(*Node)
				SelectTreeItem(*Parent)
				OnObjectTreeClick()
				*CopyNode = 0
				CheckMenuItems()
				If NoUpdate = #False
					UpdateDialog(*Parent)
				Else
					Undo_Add()
				EndIf
			EndIf
		EndIf
	EndIf
	
EndProcedure

;{ Shortcut procedures moved to main loop, due to a bug with bindevents
; Procedure OnShortCut_Delete()                       ;Key Delete pressed
; 	If CheckMenuItems(#Check_Delete)
; 		OnMenuDelete()
; 	EndIf
; EndProcedure

; Procedure OnShortCut_Copy()                         ;Key Copy pressed
; 	If CheckMenuItems(#Check_Copy)
; 		OnMenuCopy()
; 	EndIf
; EndProcedure
; 
; Procedure OnShortCut_Cut()                          ;Key Cut pressed
; 	If CheckMenuItems(#Check_Copy)
; 		OnMenuCut()
; 	EndIf
; EndProcedure
; 
; Procedure OnShortCut_Paste()                        ;Key Paste pressed
; 	If CheckMenuItems(#Check_Paste)
; 		OnMenuPaste()
; 	EndIf
; EndProcedure
;}

Runtime Procedure OnLostFocus()                    ;Add Keyboard Shortcuts
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_Delete, #ShortCut_Delete)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_C | #PB_Shortcut_Control, #ShortCut_Copy)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_X | #PB_Shortcut_Control, #ShortCut_Cut)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_V | #PB_Shortcut_Control, #ShortCut_Paste)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_F10 | #PB_Shortcut_Shift, #ShortCut_OpenContextMenu)
; 	BindEvent(#PB_Event_Menu, @OnShortCut_Delete(),  DialogWindow(#Dialog_Main), #ShortCut_Delete)
; 	BindEvent(#PB_Event_Menu, @OnShortCut_Copy(),    DialogWindow(#Dialog_Main), #ShortCut_Copy)
; 	BindEvent(#PB_Event_Menu, @OnShortCut_Cut(),     DialogWindow(#Dialog_Main), #ShortCut_Cut)
; 	BindEvent(#PB_Event_Menu, @OnShortCut_Paste(),   DialogWindow(#Dialog_Main), #ShortCut_Paste)
	BindEvent(#PB_Event_Menu, @OnObjectTreeRClick(), DialogWindow(#Dialog_Main), #ShortCut_OpenContextMenu)
EndProcedure

Runtime Procedure OnFocus()                        ;Remove Keyboard Shortcuts
	RemoveKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_Delete)
	RemoveKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_C | #PB_Shortcut_Control)
	RemoveKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_X | #PB_Shortcut_Control)
	RemoveKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_V | #PB_Shortcut_Control)
	RemoveKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_F10 | #PB_Shortcut_Shift)
EndProcedure

Runtime Procedure OnStringChanged()                ;string text changed
	Protected *node, a$, b$, c$, Key.s, Name.s, Gadget, Selected, i, j, k, UpdateDialoge = #True
	
	If EventGadget() = DialogGadget(#Dialog_Main, "comment")
		Select EventType()
			Case #PB_EventType_LostFocus
				OnLostFocus()
			Case #PB_EventType_Focus
				OnFocus()
		EndSelect
	EndIf
	i = GetGadgetState(DID("tree_objects"))
	If i > -1
		b$     = GetGadgetItemText(DID("tree_objects"), i)
		*node  = GetGadgetItemData(DID("tree_objects"), i)
		Gadget = EventGadget()
		If XMLNodeType(*node) = #PB_XML_Comment
			a$ = GetGadgetText(Gadget)
			SetXMLNodeText(*node, a$)
			If Len(a$) > Val(GetGadgetText(DID("max_chars")))
				a$ = Left(a$, Val(GetGadgetText(DID("max_chars")))) + "..."
			EndIf
			SetGadgetItemText(DID("tree_objects"), i, "<!-- " + a$ + " -->")
			ProcedureReturn 0
		EndIf
		
		Name = GetXMLNodeName(*node)
		j    = FindString(b$, "(", 1)

		ForEach DID()
			If DID() = Gadget
				Key = MapKey(DID())
				a$  = GetGadgetText(Gadget)
				Select Key
					Case "onevent_proc"
						k = GetGadgetState(DID("onevents"))
						If k = -1
							Break
						Else
							c$ = GetGadgetText(DID("onevents"))
							Key = StringField(c$, 1, ":")
							If a$
								SetGadgetItemText(DID("onevents"), k, Key + ":" + a$)
							EndIf
							Key = "_" + Key
						EndIf
					Case "expandboxitem"
						Key = "expand"
						a$  = "item:" + a$
					Case "colexpanditem"
						Key = "colexpand"
						a$  = "item:" + a$
					Case "rowexpanditem"
						Key = "rowexpand"
						a$ = "item:" + a$
					Case "marginext"
						Key = "margin"
						Selected = GetGadgetState(DID("margincombo"))
						If Selected > -1
							c$  = StringField(GetGadgetItemText(DID("margincombo"), Selected), 1, ":")
							SetGadgetItemText(DID("margincombo"), Selected, c$ + ":" + GetGadgetText(DID("marginext")))
							a$ = ""
							For i = 0 To CountGadgetItems(DID("margincombo")) - 1
								c$ = GetGadgetItemText(DID("margincombo"), i)
								If StringField(c$, 2, ":")
									If a$
										a$ + "," + c$
									Else
										a$ = c$
									EndIf
								EndIf
							Next
						Else
							ProcedureReturn 0
						EndIf
					Case "_id"
						c$ = GetGadgetText(DID("_id"))
						If j = 0
							SetGadgetItemText(DID("tree_objects"), i, b$ + " (id: " + c$ + ")")
						ElseIf Mid(b$, j + 1, 3) = "id:"
							If c$
								SetGadgetItemText(DID("tree_objects"), i, Left(b$, j - 2) + " (id: " + c$ + ")")
							Else
								SetGadgetItemText(DID("tree_objects"), i, Left(b$, j - 2))
							EndIf
						EndIf
						UpdateDialoge = #False
					Case "_name"
						c$ = GetGadgetText(DID("_name"))
						If j = 0
							SetGadgetItemText(DID("tree_objects"), i, b$ + " (" + c$ + ")")
						ElseIf Mid(b$, j + 1, 3) <> "id:"
							If c$
								SetGadgetItemText(DID("tree_objects"), i, Left(b$, j - 2) + " (" + c$ + ")")
							Else
								SetGadgetItemText(DID("tree_objects"), i, Left(b$, j - 2))
							EndIf
						EndIf
						UpdateDialoge = #False
					Case "text"
						If Name = "tab"
							c$ = GetGadgetText(DID("text"))
							If j = 0
								SetGadgetItemText(DID("tree_objects"), i, b$ + " (" + c$ + ")")
							ElseIf Mid(b$, j + 1, 3) <> "id:"
								If c$
									SetGadgetItemText(DID("tree_objects"), i, Left(b$, j - 2) + " (" + c$ + ")")
								Else
									SetGadgetItemText(DID("tree_objects"), i, Left(b$, j - 2))
								EndIf
							EndIf
						EndIf
					Case "innerwidth", "innerheight", "columns"
						If Val(a$) <= 0
							a$ = ""
						EndIf
					Case "spacing"
						If a$ = "5"
							a$ = ""
						EndIf
				EndSelect
				If a$
					SetXMLAttribute(*node, Key, a$)
				Else
					RemoveXMLAttribute(*node, Key)
				EndIf
				Break
			EndIf
		Next
		If UpdateDialoge
			UpdateDialog(*node, RefreshDelay)
		EndIf
	EndIf
EndProcedure

Procedure SwitchAttributes(XML, Mode, *node = 0)    ;some attributes need to be hidden and will be prefixed with _
	Protected i, j, k, Name.s, a$, b$, Found
	
	NewList Attr._ATTR_HELPER_()
	
	If *node = 0
		*node = RootXMLNode(XML)
		If *node
			*node = MainXMLNode(XML)
		EndIf
	EndIf
	
	If *node
		Select XMLNodeType(*node)
			Case #PB_XML_Normal
				Name = GetXMLNodeName(*node)
				If FindMapElement(DD(), Name) = 0
					ForEach DD()
						If DD()\AltName = Name
							Break
						EndIf
					Next
				EndIf
				If ExamineXMLAttributes(*node)
					While NextXMLAttribute(*node)
						AddElement(Attr())
						Attr()\Name  = XMLAttributeName(*node)
						Attr()\Value = XMLAttributeValue(*node)
						If Attr()\Name = "name"
							If FindMapElement(UsedNames(), Attr()\Value)
								k = 1
								While FindMapElement(UsedNames(), Attr()\Value + "#" + Str(k))
									k + 1
								Wend
								Attr()\Value + "#" + Str(k)
							EndIf
							UsedNames(Attr()\Value) = #True
						ElseIf Attr()\Name = "id"
							If FindMapElement(UsedIDs(), Attr()\Value)
								k = 1
								While FindMapElement(UsedIDs(), Attr()\Value + "#" + Str(k))
									k + 1
								Wend
								Attr()\Value + "#" + Str(k)
							EndIf
							UsedIDs(Attr()\Value) = #True
						EndIf
					Wend
					Found = #False
					ForEach Attr()
						If Mode
							;loading XML file and changing attributes for DDesign0r
							If FindMapElement(PossibleAttributes(), Attr()\Name) = 0
								RemoveXMLAttribute(*node, Attr()\Name)
								SetXMLAttribute(*node, "_" + Attr()\Name, Attr()\Value)
							ElseIf GetGadgetState(DialogGadget(#Dialog_Main, "definition")) > 0 And Attr()\Name = "flags"
								If DD()\FlagsNew
									a$ = Attr()\Value
									b$ = ""
									For j = 0 To CountString(a$, "|")
										For i = 0 To CountString(DD()\FlagsNew, "|")
											If Trim(StringField(a$, j + 1, "|")) = Trim(StringField(DD()\FlagsNew, i + 1, "|"))
												If b$
													b$ + "|" + Trim(StringField(DD()\FlagsOrig, i + 1, "|"))
												Else
													b$ = Trim(StringField(DD()\FlagsOrig, i + 1, "|"))
												EndIf
												Break
											EndIf
										Next i
									Next j
									SetXMLAttribute(*node, "flags", b$)
								EndIf
							EndIf
						Else
							;preparing XML for saving
							If Left(Attr()\Name, 1) = "_"
								RemoveXMLAttribute(*node, Attr()\Name)
								SetXMLAttribute(*node, Mid(Attr()\Name, 2), Attr()\Value)
								If Attr()\Name = "_name"
									Found = #True
								EndIf
							ElseIf GetGadgetState(DialogGadget(#Dialog_Main, "definition")) > 0 And Attr()\Name = "flags"
								If DD()\FlagsNew
									a$ = Attr()\Value
									b$ = ""
									For j = 0 To CountString(a$, "|")
										For i = 0 To CountString(DD()\FlagsOrig, "|")
											If Trim(StringField(a$, j + 1, "|")) = Trim(StringField(DD()\FlagsOrig, i + 1, "|"))
												If b$
													b$ + "|" + Trim(StringField(DD()\FlagsNew, i + 1, "|"))
												Else
													b$ = Trim(StringField(DD()\FlagsNew, i + 1, "|"))
												EndIf
												Break
											EndIf
										Next i
									Next j
									SetXMLAttribute(*node, "flags", b$)
								EndIf
							EndIf
						EndIf
					Next
					If Mode
						NameCounter + 1
						SetXMLAttribute(*node, "name", Str(NameCounter))
					ElseIf Found = #False
						RemoveXMLAttribute(*node, "name")
					EndIf
				EndIf
				For i = 1 To XMLChildCount(*node)
					SwitchAttributes(XML, Mode, ChildXMLNode(*node, i))
				Next i
		EndSelect
	EndIf
EndProcedure

Procedure FileSettingsDefault()                     ;Additional file settings used from default values (from preferences)
	
	SetGadgetState(DialogGadget(#Dialog_Main, "check_storeadd"), GetGadgetState(DID("save_add_file")))
	SetGadgetState(DialogGadget(#Dialog_Main, "check_storexml"), GetGadgetState(DID("store_dialog")))
EndProcedure

                                                     ;splitted LoadXMLFileRaw because of addons
Procedure LoadXMLFileFromString(XML_String.s, FileName.s, XML = #XML_Loaded, BOM = #PB_Unicode)
	Protected Result, tmpXML, i, Count, *Node, Info.s, Def.s
	
	;new 1.26
	tmpXML = CatchXML(#PB_Any, @XML_String, StringByteLength(XML_String), 0, BOM)
	Count  = XMLChildCount(RootXMLNode(tmpXML))
	For i = 1 To Count
		*Node = ChildXMLNode(RootXMLNode(tmpXML), i)
		If XMLNodeType(*Node) = #PB_XML_Comment And Left(GetXMLNodeText(*Node), 22) = "DDesign0R Definition: "
			Info = Mid(GetXMLNodeText(*Node), 23)
			Def  = StringField(Info, 1, "|")
			If FindString(Info, "|") = 0
				;older types we use the default settings
				FileSettingsDefault()
			Else
				SetGadgetState(DialogGadget(#Dialog_Main, "check_storeadd"), Val(StringField(Info, 2, "|")))
				SetGadgetState(DialogGadget(#Dialog_Main, "check_storexml"), Val(StringField(Info, 3, "|")))
			EndIf
			OnSaveAdditionalFile()
			If XML = #PB_Any And GetGadgetText(DialogGadget(#Dialog_Main, "definition")) <> Def
				LogIt(LAN("other")\Gadget("OL_011")\Text)
				FreeXML(tmpXML)
				ProcedureReturn 0
			EndIf
			SetGadgetText(DialogGadget(#Dialog_Main, "definition"), Def)
			LoadDefinition()			
			DeleteXMLNode(*Node)
			XML_String = ComposeXML(tmpXML)
			FreeXML(tmpXML)
			Break
		EndIf
	Next i
	
	If GetGadgetState(DialogGadget(#Dialog_Main, "definition")) > 0
		ForEach DD()
			If DD()\AltName
				XML_String = ReplaceString(XML_String, "<" + DD()\AltName + " ", "<" + MapKey(DD()) + " ")
			EndIf
		Next
	EndIf
	Result = CatchXML(XML, @XML_String, StringByteLength(XML_String), 0, BOM)
	If Result = 0
		LogIt(ReplaceString(LAN("other")\Gadget("OL_012")\Text, "{FILE}", FileName))
	Else
		If XML = #PB_Any
			XML = Result
		EndIf
		If XMLStatus(XML) <> #PB_XML_Success
			LogIt(ReplaceString(LAN("other")\Gadget("OL_013")\Text, "{MSG}", XMLError(XML)))
			FreeXML(XML)
			Result = 0
		Else
			
		EndIf
	EndIf
	
	ProcedureReturn Result
EndProcedure

Procedure LoadXMLFileRaw(XML.i, FileName.s)         ;main loading of xml file and handling of items
	Protected Result, XML_String.s, BOM
	
	If ReadFile(0, FileName)
		BOM = ReadStringFormat(0)
		If BOM = #PB_Ascii
			BOM = #PB_UTF8
		EndIf
		XML_String = ReadString(0, BOM | #PB_File_IgnoreEOL)
		CloseFile(0)
		Result = LoadXMLFileFromString(XML_String, FileName, XML, BOM)
	EndIf
	
	ProcedureReturn Result
EndProcedure

Procedure LoadXMLFile(FileName.s, XML.s = "")       ;load a new XML file
	Protected Result, ok
	
	If XML
		ok = LoadXMLFileFromString(XML, FileName)
	Else
		ok = LoadXMLFileRaw(#XML_Loaded, FileName)
	EndIf
	If ok
		NameCounter = 0
		Undo_Init()
		ClearMap(UsedNames())
		ClearMap(UsedIDs())
		SwitchAttributes(#XML_Loaded, 1)
		Undo_Add()
		BuildUpTree()
		DoConstantsOutput()
		Result = #True
	EndIf
	
	ProcedureReturn Result
EndProcedure

Procedure AddDialogFile(FileName.s)                 ;Dialog file came-in via drag&drop, now add the windows to the existing dialog
	Protected XML, Result, *Main, *Root, *Child, *New, i
	
	*Root = MainXMLNode(#XML_Loaded)
	If GetXMLNodeName(*Root) = "dialogs"
		XML = LoadXMLFileRaw(#PB_Any, FileName)
		If XML
			Undo_Init()
			ClearMap(UsedNames())
			ClearMap(UsedIDs())
			SwitchAttributes(XML, 1)
			*Main = MainXMLNode(XML)
			Select GetXMLNodeName(*Main)
				Case "window"
					;only one window here!
					*New = CopyXMLNode(*Main, *Root, -1)
					If *New
						StartUpDialog(*New)
					EndIf
				Case "dialogs"
					;more childs!
					For i = 1 To XMLChildCount(*Main)
						*Child = ChildXMLNode(*Main, i)
						If XMLNodeType(*Child) = #PB_XML_Normal And GetXMLNodeName(*Child) = "window"
							*New = CopyXMLNode(*Child, *Root, -1)
							If *New
								StartUpDialog(*New)
							EndIf
						EndIf
					Next i
			EndSelect
			FreeXML(XML)
			Undo_Add()
			BuildUpTree()
			DoConstantsOutput()
			Result = #True
		EndIf
	EndIf
	
	ProcedureReturn Result
EndProcedure

Procedure AddAdditionalFiles(Files.s)               ;Additional dialogs will be loaded
	Protected i
	
	For i = 0 To CountString(Files, Chr(10))
		If LCase(GetExtensionPart(StringField(Files, i + 1, Chr(10)))) <> "xml"
			LogIT(ReplaceString(LAN("other")\Gadget("OL_042")\Text, "{FILE}", GetFilePart(StringField(Files, i + 1, #LF$))))
		Else
			If AddDialogFile(StringField(Files, i + 1, Chr(10)))
				LogIT(ReplaceString(LAN("other")\Gadget("OL_043")\Text, "{FILE}", GetFilePart(StringField(Files, i + 1, #LF$))))
			Else
				LogIT(ReplaceString(LAN("other")\Gadget("OL_014")\Text, "{FILE}", GetFilePart(StringField(Files, i + 1, #LF$))))
			EndIf
		EndIf
	Next i
EndProcedure

Procedure OnObjectTreeDrop()                        ;We took care already within the DropCallBack(), so just drop it without any further testing
	Protected i, a$, *Node, *NewNode
	
	Select EventDropType()
		Case #PB_Drop_Private
			i = GetGadgetState(DID("tree_objects"))
			If i > -1
				*Node   = GetGadgetItemData(DID("tree_objects"), i)
				If *Node <> *DragNode
					Select EventDropAction()
						Case #PB_Drag_Move
							If MoveXMLNode(*DragNode, *Node, -1) = 0
								*DragNode = #Null
							EndIf
						Case #PB_Drag_Copy
							*NewNode = CopyXMLNode(*DragNode, *Node, -1)
							If *NewNode
								CopyNode(*NewNode)
							EndIf
					EndSelect
					SelectTreeItem(*DragNode)
					OnObjectTreeClick()
					UpdateDialog(*Node)
				EndIf
			EndIf
		Case #PB_Drop_Files
			a$ = EventDropFiles()
			If a$
				AddAdditionalFiles(a$)
			Else
				Debug "Damn, where are the filenames???"
			EndIf
	EndSelect

EndProcedure

Procedure OnMenuAddAdditionalFiles()                ;Adds additional XML dialogs into currently open XML
	Protected FileName.s
	
	FileName = OpenFileRequester(LAN("other")\Gadget("OL_015")\Text, "", "Dialogs (*.xml)|*.xml|All Files (*.*)|*.*", 0)
	If FileName
		AddAdditionalFiles(FileName)
		*CopyNode = 0
	EndIf

EndProcedure

Procedure CreateCutImage(Image)                     ;Create pictures with alpha blending to indicate a "cut" process
	Protected Img
	
	Img = CreateImage(#PB_Any, ImageWidth(Image), ImageHeight(Image), 32, #PB_Image_Transparent)
	If Img
		If StartDrawing(ImageOutput(Img))
			DrawAlphaImage(ImageID(Image), 0, 0, 64)
			StopDrawing()
		EndIf
	EndIf
	
	ProcedureReturn Img
EndProcedure

Macro M_GrabImage(Name)                              ;Stupid Macro to make life easier (used in LoadDialogTypeData()
	GrabImage(Img, Name, j * 16, 0, 16, 16)
	j + 1
EndMacro

Procedure LoadDialogTypeData()                      ;read the gadget attributes and fill the DD() map
	Protected Name.s, a$, b$, Type, i, j, Img
	
	Img = CatchImage(#PB_Any, ?MainIcons)
	
	Dim Flags.i(7)
	ClearMap(DD())
	j = 0
	Restore DialogInfo
	Repeat
		Read.i Type
		If Type > -1
			For i = 0 To 6
				Read.i Flags(i)
			Next i
			Read.s Name
			AddMapElement(DD(), Name)
			DD()\Type       = Type
			DD()\ImageID    = GrabImage(Img, #PB_Any, j * 16, 0, 16, 16)
			DD()\CutImageID = CreateCutImage(DD()\ImageID)
			j + 1
			a$ = ""
			Repeat
				Read.s b$
				If b$
					If a$
						a$ + "|" + b$
					Else
						a$ = b$
					EndIf
				EndIf
			Until b$ = ""
			DD()\PossibleFlags = a$
			DD()\MaxChilds     = Flags(0)
			DD()\UsableChilds  = Flags(1)
			DD()\MinSupport    = Flags(2)
			DD()\MaxSupport    = Flags(3)
			DD()\ValueSupport  = Flags(4)
			DD()\GroupSupport  = Flags(5)
			DD()\PageSupport   = Flags(6)
			Read.s DD()\PossibleEvents
		EndIf
	Until Type = -1
	M_GrabImage(#Image_UserAttr)
	M_GrabImage(#Image_Comments)
	M_GrabImage(#Image_Attr_Add)
	M_GrabImage(#Image_Attr_Del)
	M_GrabImage(#Image_Up)
	M_GrabImage(#Image_Down)
	M_GrabImage(#Image_Refresh)
	M_GrabImage(#Image_New)
	M_GrabImage(#Image_Open)
	M_GrabImage(#Image_Save)
	M_GrabImage(#Image_SaveAs)
	M_GrabImage(#Image_ShowAll)
	M_GrabImage(#Image_HideAll)
	M_GrabImage(#Image_AddDialogs)
	M_GrabImage(#Image_Preferences)
	M_GrabImage(#Image_Copy)
	M_GrabImage(#Image_Cut)
	M_GrabImage(#Image_Paste)
	M_GrabImage(#Image_Undo)
	M_GrabImage(#Image_Redo)
	M_GrabImage(#Image_SwitchContainer)
	M_GrabImage(#Image_Donate)
	M_GrabImage(#Image_Info)
	FreeImage(Img)
	ClearMap(PossibleAttributes())
	Restore PossibleAttributes
	Repeat
		Read.s a$
		If a$
			PossibleAttributes(a$) = #True
		EndIf
	Until a$ = ""
	
EndProcedure

Procedure MySaveXML(FileName.s)                     ;Save the XML file
	Protected XML.s, ext.s, tmpXML.i, *String, UseAddon, *Node, Info.s
	
	
	XML = ComposeXML(#XML_Loaded, #PB_XML_NoDeclaration)
	
	ForEach DD()
		If DD()\AltName
			XML = ReplaceString(XML, "<" + MapKey(DD()) + " ", "<" + DD()\AltName + " ")
		EndIf
	Next
	ext       = "|" + LCase(GetExtensionPart(FileName)) + "|"
	UseAddon  = #False
	ForEach AddOn()
		If FindString(AddOn()\Extensions, ext, 1, #PB_String_NoCase)
			UseAddon = #True
			Break
		EndIf
	Next
	tmpXML = CatchXML(#PB_Any, @XML, StringByteLength(XML), 0, #PB_Unicode)
	If tmpXML
		FormatXML(tmpXML, #PB_XML_ReFormat | #PB_XML_ReIndent | #PB_XML_ReduceNewline | #PB_XML_ReduceSpace | #PB_XML_CutSpace, 2)
		If UseAddon
			XML = ComposeXML(tmpXML, #PB_XML_NoDeclaration)
			FreeXML(tmpXML)
			If AddOn()\SaveXML(FileName, XML) = 0
				*String = AddOn()\GetLastError()
				If *String = 0
					LogIT(ReplaceString(LAN("other")\Gadget("OL_016")\Text, "{ADDON}", AddOn()\Name))
				Else
					LogIT(ReplaceString(ReplaceString(LAN("other")\Gadget("OL_017")\Text, "{ADDON}", AddOn()\Name), "{MSG}", PeekS(*String)))
				EndIf
			Else
				LogIT(ReplaceString(ReplaceString(LAN("other")\Gadget("OL_018")\Text, "{ADDON}", AddOn()\Name), "{FILE}", GetFilePart(FileName)))
			EndIf
		Else
			SetXMLEncoding(tmpXML, #PB_UTF8)
			;new since V1.26
			*Node = CreateXMLNode(RootXMLNode(tmpXML), "", -1, #PB_XML_Comment)
			Info = GetGadgetText(DialogGadget(#Dialog_Main, "definition")) + "|"
			Info + Str(GetGadgetState(DialogGadget(#Dialog_Main, "check_storeadd"))) + "|"
			Info + Str(GetGadgetState(DialogGadget(#Dialog_Main, "check_storexml")))
			SetXMLNodeText(*Node, "DDesign0R Definition: " + Info)
			If GetGadgetState(DialogGadget(#Dialog_Main, "check_storexml"))
				LastXML = ComposeXML(tmpXML)
			EndIf
			If SaveXML(tmpXML, FileName, #PB_XML_StringFormat) = 0
				LogIT(ReplaceString(LAN("other")\Gadget("OL_019")\Text, "{FILE}", FileName))
			Else
				LogIT(ReplaceString(LAN("other")\Gadget("OL_002")\Text, "{FILE}", GetFilePart(FileName)))
			EndIf
			FreeXML(tmpXML)
		EndIf
	Else
		LogIT(LAN("other")\Gadget("OL_021")\Text)
	EndIf
EndProcedure

Procedure GetXMLDepth(*Node)                        ;Counts the child depth
	Protected i, Count, Temp, C, Result, *N2
	
	Count = XMLChildCount(*Node)
	If Count > 0
		Result = 1
		For i = 1 To Count
			*N2 = ChildXMLNode(*Node, i)
			If *N2
				Temp = GetXMLDepth(*N2)
				If Temp > C
					C = Temp
				EndIf
			EndIf
		Next i
		Result + C
	EndIf
	
	ProcedureReturn Result
EndProcedure

Procedure SetColor()                                ;Sets color for the Color-Button (in Preferences)
	
	CreateImage(#Image_Color, 80, 24, 24, CommentColor)
	SetGadgetAttribute(DialogGadget(#Dialog_Preferences, "color_change"), #PB_Button_Image, ImageID(#Image_Color))
	RefreshDialog(#Dialog_Preferences)
	
EndProcedure
	
Runtime Procedure OnEventSaveDialog()              ;Save or Save As clicked
	Protected FileName.s

	If ActiveFile And EventGadget() = DialogGadget(#Dialog_Main, "savefile")
		
		SwitchAttributes(#XML_Loaded, 0)
		MySaveXML(ActiveFile)
		NameCounter = 0
		ClearMap(UsedNames())
		ClearMap(UsedIDs())
		SwitchAttributes(#XML_Loaded, 1)
		DoConstantsOutput(ActiveFile)
	Else
		FileName = SaveFileRequester(LAN("other")\Gadget("OL_022")\Text, ActiveFile, "Dialogs (*.xml)|*.xml|All Files (*.*)|*.*", 0)
		If FileName
			If GetExtensionPart(FileName) = ""
				FileName + ".xml"
			EndIf
			SwitchAttributes(#XML_Loaded, 0)
			MySaveXML(FileName)
			NameCounter = 0
			ClearMap(UsedNames())
			ClearMap(UsedIDs())
			SwitchAttributes(#XML_Loaded, 1)
			ActiveFile = FileName
			SetWindowTitle(DialogWindow(#Dialog_Main), ReplaceString(MAIN_TITLE, "{FILE}", GetFilePart(ActiveFile)))
			DoConstantsOutput(ActiveFile)
		EndIf
	EndIf
EndProcedure

Runtime Procedure OnEventNewDialog()               ;New Dialog clicked
	Protected GoOn, C
	
	GoOn = #True
	If IsXML(#XML_Loaded)
		;Check if we have at least three childs, if so, ask user if he really wants to open a new dialoge
		If GetXMLDepth(MainXMLNode(#XML_Loaded)) > 3
			GoOn = #False
			If MessageRequester(LAN("other")\Gadget("OL_023")\Text, LAN("other")\Gadget("OL_024")\Text, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
				GoOn = #True
			EndIf
		EndIf
		If GoOn
			ForEach OpenDialogs()
				If OpenDialogs()\WindowID And IsWindow(OpenDialogs()\WindowID)
					CloseWindow(OpenDialogs()\WindowID)
				EndIf
				DeleteElement(OpenDialogs())
			Next
			FreeXML(#XML_Loaded)
		EndIf
	EndIf
	If GoOn
		Undo_Init()
		ActiveFile  = ""
		NameCounter = 0
		ClearMap(UsedNames())
		ClearMap(UsedIDs())
		SetWindowTitle(DialogWindow(#Dialog_Main), ReplaceString(MAIN_TITLE, "{FILE}", GetFilePart(ActiveFile)))
		ClearGadgetItems(DialogGadget(#Dialog_Main, "log"))
		If CreateXML(#XML_Loaded)
			CreateXMLNode(RootXMLNode(#XML_Loaded), "dialogs")
		EndIf
		ClearTexts()
		BuildUpTree()
		DoConstantsOutput()
		DisableGadget(DialogGadget(#Dialog_Main, "definition"), 0)
		DisableAll(1)
		FileSettingsDefault()
		OnSaveAdditionalFile()
		*CopyNode = 0
		Cut\Node  = 0
	EndIf

EndProcedure

Procedure LoadDialog(FileName.s)                    ;Open Dialog
	Protected Error.s, a$, i
	Protected *String, XML.s, ext.s, UseAddon

	If FileName
		ext       = GetExtensionPart(FileName)
		UseAddon  = #False
		If ext
			ext = "|" + ext + "|"
			ForEach AddOn()
				If FindString(AddOn()\Extensions, ext, 1, #PB_String_NoCase)
					UseAddon = #True
					Break
				EndIf
			Next
		EndIf
		If UseAddon = #False
			OnEventNewDialog()
			If LoadXMLFile(FileName)
				ActiveFile = FileName
				ShowAllDialogs()
				LogIt(ReplaceString(LAN("other")\Gadget("OL_020")\Text, "{FILE}", GetFilePart(FileName)))
				DisableGadget(DialogGadget(#Dialog_Main, "definition"), 1)
				SetWindowTitle(DialogWindow(#Dialog_Main), ReplaceString(MAIN_TITLE, "{FILE}", GetFilePart(ActiveFile)))
			EndIf
		Else
			If AddOn()\GetFileType
				*String = AddOn()\GetFileType(FileName)
				If *String
					a$ = LCase(PeekS(*String))
					For i = 0 To CountGadgetItems(DialogGadget(#Dialog_Main, "definition")) - 1
						If LCase(GetGadgetItemText(DialogGadget(#Dialog_Main, "definition"), i)) = a$
							SetGadgetState(DialogGadget(#Dialog_Main, "definition"), i)
							LoadDefinition()
							Break
						EndIf
					Next i
				EndIf
			EndIf
			*String = AddOn()\LoadXML(FileName)
			If *String = 0
				LogIt(ReplaceString(ReplaceString(LAN("other")\Gadget("OL_025")\Text, "{ADDON}", AddOn()\Name), "{FILE}", FileName))
			ElseIf PeekS(*String) = ""
				*String = AddOn()\GetLastError()
				If *String
					LogIt(ReplaceString(ReplaceString(LAN("other")\Gadget("OL_026")\Text, "{ADDON}", AddOn()\Name), "{MSG}", PeekS(*String)))
				EndIf
			Else
				OnEventNewDialog()
				XML = PeekS(*String)
				If LoadXMLFile(FileName, XML)
					ActiveFile = FileName
					ShowAllDialogs()
					LogIt(ReplaceString(ReplaceString(LAN("other")\Gadget("OL_027")\Text, "{ADDON}", AddOn()\Name), "{FILE}", GetFilePart(FileName)))
					DisableGadget(DialogGadget(#Dialog_Main, "definition"), 1)
					SetWindowTitle(DialogWindow(#Dialog_Main), ReplaceString(MAIN_TITLE, "{FILE}", GetFilePart(ActiveFile)))
				EndIf
			EndIf
		EndIf
		*CopyNode = 0
	EndIf
EndProcedure

Runtime Procedure OnEventLoadDialog()              ;Open Dialog clicked
	Protected FileName.s

	FileName = OpenFileRequester(LAN("other")\Gadget("OL_028")\Text, ActiveFile, "Dialogs (*.xml)|*.xml|All Files (*.*)|*.*", 0)
	If FileName
		LoadDialog(FileName)
	EndIf

EndProcedure

Runtime Procedure OnChangeDef()                    ;ComboBox with definitions has been clicked
	Protected i
	
	LoadDefinition()
	
EndProcedure

Runtime Procedure OnDefaultSaveAdditionalFile()    ;Disable second checkbox when first is unticked (in preference dialog)
	
	If GetGadgetState(DID("save_add_file"))
		DisableGadget(DID("store_dialog"), 0)
	Else
		DisableGadget(DID("store_dialog"), 1)
		SetGadgetState(DID("store_dialog"), 0)
	EndIf
	
EndProcedure

Runtime Procedure ShowPreferences()                ;Show preferences dialog
	
	HideWindow(DialogWindow(#Dialog_Preferences), 0)
EndProcedure

Runtime Procedure ColorPicker()                    ;User wants to change the comment color
	Protected Color
	
	Color = ColorRequester(CommentColor)
	If Color <> -1 And Color <> CommentColor
		CommentColor = Color
		SetColor()
	EndIf
	
EndProcedure

Procedure OnShortCut_F2()                           ;Show/Hide the window with all of the constant names
	Protected CurrGadget
	
	If IsDialog(#Dialog_Constants) And IsWindow(DialogWindow(#Dialog_Constants))
		CurrGadget = GetActiveGadget()
		If ConstantWindowIsHidden
			HideWindow(DialogWindow(#Dialog_Constants), 0)
		Else
			HideWindow(DialogWindow(#Dialog_Constants), 1)
		EndIf
		ConstantWindowIsHidden ! 1
		SetActiveGadget(CurrGadget)
	EndIf
EndProcedure

Procedure CreateMainPopup()                         ;Create main popup-menu of DD
	Protected i
	
	NewList SH._SORTHELPER_()
	ForEach DD()
		If DD()\Type <> #DialogType_Dialogs
			AddElement(SH())
			SH()\Name = MapKey(DD())
			SH()\DD   = @DD()
		EndIf
	Next
	SortStructuredList(SH(), #PB_Sort_Ascending, OffsetOf(_SORTHELPER_\Name), #PB_String)
	
	CreatePopupImageMenu(#Popup_Menu_Tree)
	MenuItem(#TreeMenu_AddWindow, LAN("other")\Gadget("OL_029")\Text, ImageID(DD("window")\ImageID))
	MenuBar()
	SubMenuHandles(#SubMenu_AddChilds) = OpenSubMenu(LAN("other")\Gadget("OL_030")\Text)
	ForEach SH()
		Select SH()\DD\Type
			Case #DialogType_HBox, #DialogType_VBox, #DialogType_GridBox, #DialogType_MultiBox, #DialogType_SingleBox, #DialogType_Window
				;ignore
			Case #DialogType_Container, #DialogType_Frame, #DialogType_ScrollArea;, #DialogType_Tab
				;ignore
			Default
				MenuItem(SH()\DD\Type, SH()\Name, ImageID(SH()\DD\ImageID))
		EndSelect
	Next
	CloseSubMenu()
	SubMenuHandles(#SubMenu_AddSingleContainer) = OpenSubMenu(LAN("other")\Gadget("OL_031")\Text)
	MenuItem(#DialogType_SingleBox, "SingleBox", ImageID(DD("singlebox")\ImageID))
	ForEach SH()
		Select SH()\DD\Type
			Case #DialogType_Container, #DialogType_Frame, #DialogType_ScrollArea;, #DialogType_Tab
				MenuItem(SH()\DD\Type, SH()\Name, ImageID(SH()\DD\ImageID))
		EndSelect
	Next
	CloseSubMenu()
	SubMenuHandles(#SubMenu_AddMultiContainer) = OpenSubMenu(LAN("other")\Gadget("OL_032")\Text)
		MenuItem(#DialogType_VBox, "vBox", ImageID(DD("vbox")\ImageID))
		MenuItem(#DialogType_HBox, "hBox", ImageID(DD("hbox")\ImageID))
		MenuItem(#DialogType_GridBox, "GridBox", ImageID(DD("gridbox")\ImageID))
		MenuItem(#DialogType_MultiBox, "MultiBox", ImageID(DD("multibox")\ImageID))
	CloseSubMenu()
	MenuItem(#TreeMenu_SwitchContainer, LAN("other")\Gadget("OL_033")\Text, ImageID(#Image_SwitchContainer))
	
	MenuItem(#TreeMenu_MoveChildUp, LAN("other")\Gadget("OL_034")\Text, ImageID(#Image_Up))
	MenuItem(#TreeMenu_MoveChildDown, LAN("other")\Gadget("OL_035")\Text, ImageID(#Image_Down))
	MenuBar()
	MenuItem(#TreeMenu_Copy, LAN("other")\Gadget("OL_036")\Text, ImageID(#Image_Copy))
	MenuItem(#TreeMenu_Cut, LAN("other")\Gadget("OL_037")\Text, ImageID(#Image_Cut))
	MenuItem(#TreeMenu_Paste, LAN("other")\Gadget("OL_038")\Text, ImageID(#Image_Paste))
	MenuBar()
	MenuItem(#TreeMenu_AddComment, LAN("other")\Gadget("OL_039")\Text, ImageID(#Image_Comments))
	MenuBar()
	MenuItem(#TreeMenu_LoadAdditionalDialoge, LAN("other")\Gadget("OL_040")\Text, ImageID(#Image_AddDialogs))	
	MenuBar()
	MenuItem(#TreeMenu_Delete, LAN("other")\Gadget("OL_041")\Text, ImageID(#Image_Attr_Del))
	
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_MoveChildUp,           @OnMenuMoveUp())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_MoveChildDown,         @OnMenuMoveDown())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_AddWindow,             @OnMenuAddWindow())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_Delete,                @OnMenuDelete())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_AddComment,            @OnMenuAddComment())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_LoadAdditionalDialoge, @OnMenuAddAdditionalFiles())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_Copy,                  @OnMenuCopy())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_Cut,                   @OnMenuCut())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_Paste,                 @OnMenuPaste())
	BindMenuEvent(#Popup_Menu_Tree,       #TreeMenu_SwitchContainer,       @OnContainerSwitch())
	
	For i = #DialogType_Window To #DialogType_SingleBox
		BindMenuEvent(#Popup_Menu_Tree, i, @OnMenuAddChild())
	Next i
EndProcedure

Runtime Procedure OnLanguageChange()               ;Change language
	Protected Lang$, ok, JSON, Key$, GKey$
	
	Lang$ = GetGadgetText(DialogGadget(#Dialog_Preferences, "language"))
	If LCase(Lang$) <> "english"
		JSON = LoadJSON(#PB_Any, GetPathPart(ProgramFilename()) + Lang$ + ".lan")
		If JSON
			ExtractJSONMap(JSONValue(JSON), LAN())
			If MapSize(LAN()) > 4
				ok = #True
			EndIf
			FreeJSON(JSON)
		Else
			LogIT("Error in Language file '" + Lang$ + ".lan': " + JSONErrorMessage() + " in line: " + Str(JSONErrorLine()) + " pos: " + Str(JSONErrorPosition()))
			logit("Switching back to English...")
		EndIf
	EndIf
	If ok = #False
		JSON = CatchJSON(#PB_Any, ?MainDialogEnd, ?MainIcons - ?MainDialogEnd, #PB_UTF8)
		If JSON
			ExtractJSONMap(JSONValue(JSON), LAN())
			FreeJSON(JSON)
		EndIf
	EndIf
	
	ForEach LAN()
		Key$ = MapKey(LAN())
		If LCase(Key$) <> "other"
			If LAN()\Title
				SetWindowTitle(DialogWindow(DDD(Key$)), LAN()\Title)
			EndIf
			ForEach LAN()\Gadget()
				GKey$ = MapKey(LAN()\Gadget())
				If LAN()\Gadget()\Text
					SetGadgetText(DialogGadget(DDD(Key$), GKey$), LAN()\Gadget()\Text)
				EndIf
				If LAN()\Gadget()\ToolTipp
					GadgetToolTip(DialogGadget(DDD(Key$), GKey$), LAN()\Gadget()\ToolTipp)
				EndIf
			Next
			RefreshDialog(DDD(Key$))
		EndIf
	Next
	CreateMainPopup()
	
EndProcedure

Runtime Procedure OnDonateClick()                  ;
	OpenOnlineURL("https://www.paypal.me/hex0r")
EndProcedure

Runtime Procedure OnClickInfo()
	MessageRequester("Dialog Design0R " + #MY_VERSION, "Dialog Design0R is ©HeX0R" + #LF$ + "2018-2019" + #LF$ + "http://hex0rs.coderbu.de", #PB_MessageRequester_Info)
EndProcedure

Procedure OpenWindow_Main()                         ;Opens main window, set all tooltipps, bind events, add items, add menus, ...
	Protected i
	
	
	
	CatchXML(#XML_Main, ?MainDialog, ?MainDialogEnd - ?MainDialog, 0, #PB_UTF8)
	CreateDialog(#Dialog_Main)
	OpenXMLDialog(#Dialog_Main, #XML_Main, "Window_Main")
	CreateDialog(#Dialog_UserAttr)
	OpenXMLDialog(#Dialog_UserAttr,        #XML_Main, "Win_Attrib",          0, 0, 300, 200, WindowID(DialogWindow(#Dialog_Main)))
	CreateDialog(#Dialog_Constants)
	OpenXMLDialog(#Dialog_Constants,       #XML_Main, "Win_Constants",       0, 0, 300, 400, WindowID(DialogWindow(#Dialog_Main)))
	CreateDialog(#Dialog_Preferences)
	OpenXMLDialog(#Dialog_Preferences,     #XML_Main, "Win_Preferences",     0, 0, 300, 400, WindowID(DialogWindow(#Dialog_Main)))
	CreateDialog(#Dialog_SwitchContainer)
	OpenXMLDialog(#Dialog_SwitchContainer, #XML_Main, "Win_SwitchContainer", 0, 0, 50, 50,   WindowID(DialogWindow(#Dialog_Main)))
;   Debug DialogError(#Dialog_Main)
;   Debug DialogError(#Dialog_UserAttr)
;   CallDebugger
	DDD("Window_Main")         = #Dialog_Main
	DDD("Win_Attrib")          = #Dialog_UserAttr
	DDD("Win_Constants")       = #Dialog_Constants
	DDD("Win_Preferences")     = #Dialog_Preferences
	DDD("Win_SwitchContainer") = #Dialog_SwitchContainer
	
	CompilerIf #PB_Compiler_OS = #PB_OS_Windows
		;helps against splitter flickering
		SetWindowLongPtr_(GadgetID(DialogGadget(#Dialog_Main, "splitter")), #GWL_EXSTYLE, #WS_EX_COMPOSITED)
	CompilerEndIf
	
	DID("tree_objects")   = DialogGadget(#Dialog_Main,        "tree_objects")
	DID("_id")            = DialogGadget(#Dialog_Main,        "_id")
	DID("_name")          = DialogGadget(#Dialog_Main,        "_name")
	DID("text")           = DialogGadget(#Dialog_Main,        "text")
	DID("min")            = DialogGadget(#Dialog_Main,        "min")
	DID("max")            = DialogGadget(#Dialog_Main,        "max")
	DID("value")          = DialogGadget(#Dialog_Main,        "value")
	DID("group")          = DialogGadget(#Dialog_Main,        "group")
	DID("invisible")      = DialogGadget(#Dialog_Main,        "invisible")
	DID("disabled")       = DialogGadget(#Dialog_Main,        "disabled")
	DID("width")          = DialogGadget(#Dialog_Main,        "width")
	DID("height")         = DialogGadget(#Dialog_Main,        "height")
	DID("flags")          = DialogGadget(#Dialog_Main,        "flags")
	DID("onevents")       = DialogGadget(#Dialog_Main,        "onevents")
	DID("onevent_proc")   = DialogGadget(#Dialog_Main,        "onevent_proc")
	DID("minwidth")       = DialogGadget(#Dialog_Main,        "minwidth")
	DID("minheight")      = DialogGadget(#Dialog_Main,        "minheight")
	DID("maxwidth")       = DialogGadget(#Dialog_Main,        "maxwidth")
	DID("maxheight")      = DialogGadget(#Dialog_Main,        "maxheight")
	DID("spacing")        = DialogGadget(#Dialog_Main,        "spacing")
	DID("alignbox")       = DialogGadget(#Dialog_Main,        "alignbox")
	DID("expandbox")      = DialogGadget(#Dialog_Main,        "expandbox")
	DID("expandboxitem")  = DialogGadget(#Dialog_Main,        "expandboxitem")
	DID("columns")        = DialogGadget(#Dialog_Main,        "columns")
	DID("colspacing")     = DialogGadget(#Dialog_Main,        "colspacing")
	DID("rowspacing")     = DialogGadget(#Dialog_Main,        "rowspacing")
	DID("colexpand")      = DialogGadget(#Dialog_Main,        "colexpand")
	DID("colexpanditem")  = DialogGadget(#Dialog_Main,        "colexpanditem")
	DID("rowexpand")      = DialogGadget(#Dialog_Main,        "rowexpand")
	DID("rowexpanditem")  = DialogGadget(#Dialog_Main,        "rowexpanditem")
	DID("margincombo")    = DialogGadget(#Dialog_Main,        "margincombo")
	DID("marginext")      = DialogGadget(#Dialog_Main,        "marginext")
	DID("expandsingle")   = DialogGadget(#Dialog_Main,        "expandsingle")
	DID("alignsingle")    = DialogGadget(#Dialog_Main,        "alignsingle")
	DID("expandwidth")    = DialogGadget(#Dialog_Main,        "expandwidth")
	DID("expandheight")   = DialogGadget(#Dialog_Main,        "expandheight")
	DID("firstmin")       = DialogGadget(#Dialog_Main,        "firstmin")
	DID("secondmin")      = DialogGadget(#Dialog_Main,        "secondmin")
	DID("colspan")        = DialogGadget(#Dialog_Main,        "colspan")
	DID("rowspan")        = DialogGadget(#Dialog_Main,        "rowspan")
	DID("page")           = DialogGadget(#Dialog_Main,        "page")
	DID("scrolling")      = DialogGadget(#Dialog_Main,        "scrolling")
	DID("innerheight")    = DialogGadget(#Dialog_Main,        "innerheight")
	DID("innerwidth")     = DialogGadget(#Dialog_Main,        "innerwidth")
	DID("userattributes") = DialogGadget(#Dialog_Main,        "userattributes")
	;none direct dialog attributes
	DID("refresh")        = DialogGadget(#Dialog_Main,        "refresh")
	DID("refreshdelay")   = DialogGadget(#Dialog_Preferences, "refreshdelay")
	DID("refreshtime")    = DialogGadget(#Dialog_Preferences, "refreshtime")
	DID("store_dialog")   = DialogGadget(#Dialog_Preferences, "check_storedialogalso")
	DID("save_add_file")  = DialogGadget(#Dialog_Preferences, "check_saveadditionaldata")
	DID("enable_color")   = DialogGadget(#Dialog_Preferences, "check_enablecolor")
	DID("max_chars")      = DialogGadget(#Dialog_Preferences, "max_characters")
	DID("conf_del")       = DialogGadget(#Dialog_Preferences, "check_confirm_delete")
	DID("conf_close")     = DialogGadget(#Dialog_Preferences, "check_confirm_close")
	;When adding more, make sure to ignore them in the "ClearTexts()" procedure!
	
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "newfile"),           #PB_Button_Image, ImageID(#Image_New))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "loadfile"),          #PB_Button_Image, ImageID(#Image_Open))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "savefile"),          #PB_Button_Image, ImageID(#Image_Save))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "savefileas"),        #PB_Button_Image, ImageID(#Image_SaveAs))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "showall"),           #PB_Button_Image, ImageID(#Image_ShowAll))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "hideall"),           #PB_Button_Image, ImageID(#Image_HideAll))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "move_up"),           #PB_Button_Image, ImageID(#Image_Up))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "move_down"),         #PB_Button_Image, ImageID(#Image_Down))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "undo"),              #PB_Button_Image, ImageID(#Image_Undo))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "redo"),              #PB_Button_Image, ImageID(#Image_Redo))
	SetGadgetAttribute(DialogGadget(#Dialog_Main, "prefs"),             #PB_Button_Image, ImageID(#Image_Preferences))
	SetGadgetAttribute(DialogGadget(#Dialog_Preferences, "donate"),     #PB_Button_Image, ImageID(#Image_Donate))
	SetGadgetAttribute(DialogGadget(#Dialog_Preferences, "infobutton"), #PB_Button_Image, ImageID(#Image_Info))
	SetGadgetAttribute(DID("refresh"),                                  #PB_Button_Image, ImageID(#Image_Refresh))
	SetGadgetAttribute(DID("userattributes"),                           #PB_Button_Image, ImageID(#Image_UserAttr))
	SetGadgetAttribute(DialogGadget(#Dialog_UserAttr, "attrib_add"),    #PB_Button_Image, ImageID(#Image_Attr_Add))
	SetGadgetAttribute(DialogGadget(#Dialog_UserAttr, "attrib_del"),    #PB_Button_Image, ImageID(#Image_Attr_Del))

	EnableGadgetDrop(DID("tree_objects"), #PB_Drop_Private, #PB_Drag_Move | #PB_Drag_Copy, 1)
	EnableGadgetDrop(DID("tree_objects"), #PB_Drop_Files, #PB_Drag_Copy)
	SetDropCallback(@DropCallback())
	AddWindowTimer(DialogWindow(#Dialog_Main), #Timer_Main, 50)

	
	;Init Comboboxes
	AddGadgetItem(DID("expandbox"),    -1, "yes")
	AddGadgetItem(DID("expandbox"),    -1, "no")
	AddGadgetItem(DID("expandbox"),    -1, "equal")
	AddGadgetItem(DID("expandbox"),    -1, "item:")
	AddGadgetItem(DID("alignbox"),     -1, "top/left")
	AddGadgetItem(DID("alignbox"),     -1, "center")
	AddGadgetItem(DID("alignbox"),     -1, "bottom/right")
	AddGadgetItem(DID("colexpand"),    -1, "yes")
	AddGadgetItem(DID("colexpand"),    -1, "no")
	AddGadgetItem(DID("colexpand"),    -1, "equal")
	AddGadgetItem(DID("colexpand"),    -1, "item:")
	AddGadgetItem(DID("rowexpand"),    -1, "yes")
	AddGadgetItem(DID("rowexpand"),    -1, "no")
	AddGadgetItem(DID("rowexpand"),    -1, "equal")
	AddGadgetItem(DID("rowexpand"),    -1, "item:")
	AddGadgetItem(DID("expandsingle"), -1, "yes")
	AddGadgetItem(DID("expandsingle"), -1, "no")
	AddGadgetItem(DID("expandsingle"), -1, "vertical")
	AddGadgetItem(DID("expandsingle"), -1, "horizontal")
	AddGadgetItem(DID("alignsingle"),  -1, "top")
	AddGadgetItem(DID("alignsingle"),  -1, "left")
	AddGadgetItem(DID("alignsingle"),  -1, "bottom")
	AddGadgetItem(DID("alignsingle"),  -1, "right")
	AddGadgetItem(DID("alignsingle"),  -1, "center")
	AddGadgetItem(DID("scrolling"),    -1, "vertical")
	AddGadgetItem(DID("scrolling"),    -1, "horizontal")
	AddGadgetItem(DID("scrolling"),    -1, "both")
	AddGadgetItem(DialogGadget(#Dialog_Preferences, "language"), -1, "English")
	AddGadgetItem(DialogGadget(#Dialog_Main,  "definition"),   -1, "PureBasic")
	ResetMarginCombo()
	SetGadgetState(DialogGadget(#Dialog_Preferences, "language"), 0)
	SetGadgetState(DialogGadget(#Dialog_Main,  "definition"), 0)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_F2, #ShortCut_F2)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_F5, #ShortCut_ShowAll)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_F6, #ShortCut_HideAll)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_F12, #ShortCut_Debug)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_Z | #PB_Shortcut_Control, #ShortCut_Undo)
	AddKeyboardShortcut(DialogWindow(#Dialog_Main), #PB_Shortcut_Y | #PB_Shortcut_Control, #ShortCut_Redo)
	
	;BindEvents
	;TODO D&D Linux Bug in PB
	;see https://www.purebasic.fr/english/viewtopic.php?f=23&t=70466
	CompilerIf #PB_Compiler_OS <> #PB_OS_Linux
		BindEvent(#PB_Event_GadgetDrop,       @OnObjectTreeDrop(),  DialogWindow(#Dialog_Main), DID("tree_objects"))
	CompilerEndIf
	BindEvent(#PB_Event_Timer,            @OnTimerEvent(),       DialogWindow(#Dialog_Main))
	BindEvent(#Event_RefreshMainWindow,   @RefreshMainDialog(),  DialogWindow(#Dialog_Main))
	BindEvent(#PB_Event_Menu,             @OnShortCut_F2(),      DialogWindow(#Dialog_Main), #ShortCut_F2)
	BindEvent(#PB_Event_Menu,             @OnClickShowAll(),     DialogWindow(#Dialog_Main), #ShortCut_ShowAll)
	BindEvent(#PB_Event_Menu,             @OnClickHideAll(),     DialogWindow(#Dialog_Main), #ShortCut_HideAll)
	BindEvent(#PB_Event_Menu,             @OnDebug(),            DialogWindow(#Dialog_Main), #ShortCut_Debug)
	BindEvent(#PB_Event_Menu,             @OnShortCut_Undo(),    DialogWindow(#Dialog_Main), #ShortCut_Undo)
	BindEvent(#PB_Event_Menu,             @OnShortCut_Redo(),    DialogWindow(#Dialog_Main), #ShortCut_Redo)
	
	OnLostFocus()
	RefreshDialog(#Dialog_Main)
	
EndProcedure

Procedure main()                                    ;main procedure, not much in it, we use almost only bind events
	Protected FileName.s, F, Portable, i, j, x, y, w, h
	;Init
	If FileSize(GetPathPart(ProgramFilename()) + "save_template.json") = -1 And FileSize(GetPathPart(ProgramFilename()) + "default_save_template.json") > 0
		CopyFile(GetPathPart(ProgramFilename()) + "default_save_template.json", GetPathPart(ProgramFilename()) + "save_template.json")
	EndIf
	ElapsedMilliseconds()      ;need this, because it will not run before you call it once (since when? PB5.62??)
	LoadDialogTypeData()			 ;initialize the DD() map
	InitAddOns()
	OpenWindow_Main()          ;open main window
	OnEventNewDialog()         ;reset all gadgets to default
	OnObjectTreeClick()				 ;make sure that all is disabled, as long as no tree item is selected
	;Scan for *.def files
	If ExamineDirectory(0, GetPathPart(ProgramFilename()), "*.*")
		While NextDirectoryEntry(0)
			If DirectoryEntryType(0) = #PB_DirectoryEntry_File
				Select LCase(GetExtensionPart(DirectoryEntryName(0)))
					Case "def"
						AddGadgetItem(DialogGadget(#Dialog_Main, "definition"), -1, Left(DirectoryEntryName(0), Len(DirectoryEntryName(0)) - 4))
					Case "lan"
						If LCase(DirectoryEntryName(0)) <> "english.lan"
							AddGadgetItem(DialogGadget(#Dialog_Preferences, "language"), -1, Left(DirectoryEntryName(0), Len(DirectoryEntryName(0)) - 4))
						EndIf
				EndSelect
			EndIf
		Wend
		FinishDirectory(0)
	EndIf
	
	;check program parameters and open preferences
	For i = 0 To CountProgramParameters() - 1
		Select ProgramParameter(i)
			Case "/portable"
				Portable = #True
			Default
				FileName = ProgramParameter(i)
		EndSelect
	Next i
				
	If Portable Or FileSize(GetPathPart(ProgramFilename()) + "settings.prefs") > 0
		Portable = #True
		OpenPreferences(GetPathPart(ProgramFilename()) + "settings.prefs")
	Else
		OpenPreferences(GetUserDirectory(#PB_Directory_ProgramData) + "hex0r/DDesign0r/settings.prefs")
	EndIf
	PreferenceGroup("win_main")
	x = ReadPreferenceInteger("x", #PB_Ignore)
	y = ReadPreferenceInteger("y", #PB_Ignore)
	w = ReadPreferenceInteger("w", #PB_Ignore)
	h = ReadPreferenceInteger("h", #PB_Ignore)
	CheckWindowXY(@x, @y, @w, @h, 800, 700)
	ResizeWindow(DialogWindow(#Dialog_Main), x, y, w, h)
	PreferenceGroup("win_attrib")
	x = ReadPreferenceInteger("x", #PB_Ignore)
	y = ReadPreferenceInteger("y", #PB_Ignore)
	w = ReadPreferenceInteger("w", #PB_Ignore)
	h = ReadPreferenceInteger("h", #PB_Ignore)
	CheckWindowXY(@x, @y, @w, @h, 160, 180)
	ResizeWindow(DialogWindow(#Dialog_UserAttr), x, y, w, h)
	PreferenceGroup("win_constant")
	x = ReadPreferenceInteger("x", #PB_Ignore)
	y = ReadPreferenceInteger("y", #PB_Ignore)
	w = ReadPreferenceInteger("w", #PB_Ignore)
	h = ReadPreferenceInteger("h", #PB_Ignore)
	CheckWindowXY(@x, @y, @w, @h, 300, 400)
	ResizeWindow(DialogWindow(#Dialog_Constants), x, y, w, h)
	PreferenceGroup("win_prefs")
	x = ReadPreferenceInteger("x", #PB_Ignore)
	y = ReadPreferenceInteger("y", #PB_Ignore)
	ResizeWindow(DialogWindow(#Dialog_Preferences), x, y, #PB_Ignore, #PB_Ignore)
	
	
	PreferenceGroup("main")
	SetGadgetText(DialogGadget(#Dialog_Preferences, "language"), ReadPreferenceString("language", "English"))
	OnLanguageChange()
	ConstantWindowIsHidden = ReadPreferenceInteger("ConstantWindowHidden", 0)
	SetGadgetState(DID("save_add_file"), ReadPreferenceInteger("SaveAdditionalConstantFile", 0))
	SetGadgetState(DID("store_dialog"),  ReadPreferenceInteger("StoreDialogInFile", 0))
	SetGadgetState(DID("conf_del"),      ReadPreferenceInteger("ConfirmDeleting", 1))
	SetGadgetState(DID("conf_close"),    ReadPreferenceInteger("ConfirmClosing", 1))
	
	i = ReadPreferenceInteger("load_last_dialog", 0)
	SetGadgetState(DialogGadget(#Dialog_Preferences, "check_load_lastdialog"), i)
	If i And FileName = ""
		FileName = ReadPreferenceString("LastUsedDialog", "")
	EndIf
	OnDefaultSaveAdditionalFile()
	FileSettingsDefault()
	OnSaveAdditionalFile()
	
	
	i = ReadPreferenceInteger("splitter", 250)
	M_InitializeSplitter(i)
	SetGadgetState(DID("refreshdelay"), ReadPreferenceInteger("refresh", 3))
	SetGadgetText(DID("max_chars"), Str(ReadPreferenceInteger("maxcommentlength", 24)))
	CommentColor     = ReadPreferenceInteger("commentcolor", -1)
	SetGadgetState(DID("enable_color"), ReadPreferenceInteger("use_color", 0))
	ClosePreferences()
	SetColor()
	ColorComments()
	OnRefreshDelay()
	HideWindow(DialogWindow(#Dialog_Main), 0)
	
	M_InitSplitter
	If FileName And FileSize(FileName) > 0
		LoadDialog(FileName)
	EndIf
	
	Repeat
		Select WaitWindowEvent()
			Case #PB_Event_CloseWindow
				F = #False
				ForEach OpenDialogs()
					If OpenDialogs()\WindowID And OpenDialogs()\WindowID = EventWindow()
						F = #True
						HideWindow(EventWindow(), 1) ;we just hide the window, no need to close it now, will reopen as soon as user changes something or presses the "refresh" button
						ItemSelect()
						Break
					EndIf
				Next
				If F = #False
					If EventWindow() = DialogWindow(#Dialog_UserAttr) Or EventWindow() = DialogWindow(#Dialog_SwitchContainer)
						HideWindow(EventWindow(), 1)
					ElseIf EventWindow() = DialogWindow(#Dialog_Preferences)
						HideWindow(EventWindow(), 1)
						BuildUpTree()
					ElseIf EventWindow() = DialogWindow(#Dialog_Constants)
						HideWindow(EventWindow(), 1)
						ConstantWindowIsHidden = #True
					Else
						;main window closing. Do a smart check
						If GetGadgetState(DID("conf_close")) = 0
							;option "confirm when closing" is unticked, so close immediately
							Break
						ElseIf IsXML(#XML_Loaded) = 0
							;there is no XML loaded (should be impossible, but who knows...)
							Break
						ElseIf GetXMLDepth(MainXMLNode(#XML_Loaded)) < 1
							;This is an empty dialoge, we don't have to ask the user
							Break
							;o.k. let the user decide what to do.
						ElseIf MessageRequester(LAN("other")\Gadget("OL_046")\Text, LAN("other")\Gadget("OL_047")\Text, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
							Break
						EndIf
					EndIf
				EndIf
			Case #PB_Event_GadgetDrop
				M_GadgetDrop
				
			Case #PB_Event_Menu	
				Select EventMenu()
					Case #ShortCut_Delete
						If CheckMenuItems(#Check_Delete)
							OnMenuDelete()
						EndIf
					Case #ShortCut_Copy
						If CheckMenuItems(#Check_Copy)
							OnMenuCopy()
						EndIf
					Case #ShortCut_Cut
						If CheckMenuItems(#Check_Copy)
							OnMenuCut()
						EndIf
					Case #ShortCut_Paste
						If CheckMenuItems(#Check_Paste)
							OnMenuPaste()
						EndIf
				EndSelect
		EndSelect
	ForEver
	
	If Portable
		OpenPreferences(GetPathPart(ProgramFilename()) + "settings.prefs")
	Else
		If FileSize(GetUserDirectory(#PB_Directory_ProgramData) + "hex0r/") <> -2
			CreateDirectory(GetUserDirectory(#PB_Directory_ProgramData) + "hex0r/")
		EndIf
		If FileSize(GetUserDirectory(#PB_Directory_ProgramData) + "hex0r/DDesign0r/") <> -2
			CreateDirectory(GetUserDirectory(#PB_Directory_ProgramData) + "hex0r/DDesign0r/")
		EndIf
		OpenPreferences(GetUserDirectory(#PB_Directory_ProgramData) + "hex0r/DDesign0r/settings.prefs")
	EndIf
	PreferenceGroup("win_main")
	WritePreferenceInteger("x",                          WindowX(DialogWindow(#Dialog_Main)))
	WritePreferenceInteger("y",                          WindowY(DialogWindow(#Dialog_Main)))
	WritePreferenceInteger("w",                          WindowWidth(DialogWindow(#Dialog_Main)))
	WritePreferenceInteger("h",                          WindowHeight(DialogWindow(#Dialog_Main)))
	PreferenceGroup("win_attrib")
	WritePreferenceInteger("x",                          WindowX(DialogWindow(#Dialog_UserAttr)))
	WritePreferenceInteger("y",                          WindowY(DialogWindow(#Dialog_UserAttr)))
	WritePreferenceInteger("w",                          WindowWidth(DialogWindow(#Dialog_UserAttr)))
	WritePreferenceInteger("h",                          WindowHeight(DialogWindow(#Dialog_UserAttr)))
	PreferenceGroup("win_constant")
	WritePreferenceInteger("x",                          WindowX(DialogWindow(#Dialog_Constants)))
	WritePreferenceInteger("y",                          WindowY(DialogWindow(#Dialog_Constants)))
	WritePreferenceInteger("w",                          WindowWidth(DialogWindow(#Dialog_Constants)))
	WritePreferenceInteger("h",                          WindowHeight(DialogWindow(#Dialog_Constants)))
	PreferenceGroup("win_prefs")
	WritePreferenceInteger("x",                          WindowX(DialogWindow(#Dialog_Preferences)))
	WritePreferenceInteger("y",                          WindowY(DialogWindow(#Dialog_Preferences)))
	
	PreferenceGroup("main")
	WritePreferenceString("language",                    GetGadgetText(DialogGadget(#Dialog_Preferences, "language")))
	WritePreferenceInteger("ConstantWindowHidden",       ConstantWindowIsHidden)
	WritePreferenceInteger("ConfirmDeleting",            GetGadgetState(DID("conf_del")))
	WritePreferenceInteger("ConfirmClosing",             GetGadgetState(DID("conf_close")))
	WritePreferenceInteger("SaveAdditionalConstantFile", GetGadgetState(DID("save_add_file")))
	WritePreferenceInteger("StoreDialogInFile",          GetGadgetState(DID("store_dialog")))
	WritePreferenceInteger("splitter",                   GetGadgetState(DialogGadget(#Dialog_Main, "splitter")))
	WritePreferenceInteger("refresh",                    GetGadgetState(DID("refreshdelay")))
	WritePreferenceInteger("maxcommentlength",           Val(GetGadgetText(DID("max_chars"))))
	WritePreferenceInteger("commentcolor",               CommentColor)
	WritePreferenceInteger("use_color",                  GetGadgetState(DID("enable_color")))
	WritePreferenceInteger("load_last_dialog",           GetGadgetState(DialogGadget(#Dialog_Preferences, "check_load_lastdialog")))
	WritePreferenceString("LastUsedDialog",              ActiveFile)
	ClosePreferences()
	
	ForEach AddOn()
		CloseLibrary(AddOn()\DLL)
	Next
	
EndProcedure

main()
End

;{ - Data Section
DataSection
	DialogInfo:
	Data.i #DialogType_Dialogs, -1, #DialogType_Window, 0, 0, 0, 0, 0  ;<- Type, Max Childs (-1 = no limit), Possible Childs, min support, max support, value support, group support, page support
	Data.s "dialogs", ""                                               ;<- name in XML, possible flags ends with ""
	Data.s ""                                                          ;<- onxxxevent()... support
	;
	Data.i #DialogType_Window, 1, -1, 0, 0, 0, 0, 0
	Data.s "window"
	Data.s "#PB_Window_SystemMenu", "#PB_Window_MinimizeGadget", "#PB_Window_MaximizeGadget", "#PB_Window_SizeGadget", "#PB_Window_Invisible"
	Data.s "#PB_Window_TitleBar", "#PB_Window_Tool", "#PB_Window_BorderLess", "#PB_Window_ScreenCentered", "#PB_Window_WindowCentered"
	Data.s "#PB_Window_Maximize", "#PB_Window_Minimize", "#PB_Window_NoGadgets", "#PB_Window_NoActivate", ""
	Data.s ""
	;
	Data.i #DialogType_Button, 0, 0, 0, 0, 0, 0, 0                                                                                 
	Data.s "button"                                                                                                      
	Data.s "#PB_Button_Right", "#PB_Button_Left", "#PB_Button_MultiLine", "#PB_Button_Default", "#PB_Button_Toggle", ""
	Data.s "onevent"
	;
	Data.i #DialogType_ButtonImage, 0, 0, 0, 0, 0, 0, 0
	Data.s "buttonimage"
	Data.s "#PB_Button_Toggle", ""
	Data.s "onevent"
	;
	Data.i #DialogType_Calendar, 0, 0, 0, 0, 0, 0, 0
	Data.s "calendar"
	CompilerIf #PB_Compiler_OS = #PB_OS_Windows
		Data.s "#PB_Calendar_Borderless"
	CompilerEndIf
	Data.s ""
	Data.s "onevent"
	;
	Data.i #DialogType_Canvas, 0, 0, 0, 0, 0, 0, 0
	Data.s "canvas"
	Data.s "#PB_Canvas_Border", "#PB_Canvas_ClipMouse", "#PB_Canvas_Keyboard", "#PB_Canvas_DrawFocus", ""
	Data.s "onevent"
	;
	Data.i #DialogType_CheckBox, 0, 0, 0, 0, 0, 0, 0
	Data.s "checkbox"
	Data.s "#PB_CheckBox_Right", "#PB_CheckBox_Center", "#PB_CheckBox_ThreeState", ""
	Data.s "onevent"
	;
	Data.i #DialogType_ComboBox, 0, 0, 0, 0, 0, 0, 0
	Data.s "combobox"
	Data.s "#PB_ComboBox_Editable", "#PB_ComboBox_LowerCase", "#PB_ComboBox_UpperCase", "#PB_ComboBox_Image", ""
	Data.s "onevent,onchange,onfocus,onlostfocus"
	
	;
	Data.i #DialogType_Container, 1, -1, 0, 0, 0, 0, 0
	Data.s "container"
	Data.s "#PB_Container_BorderLess", "#PB_Container_Flat", "#PB_Container_Raised", "#PB_Container_Single", "#PB_Container_Double", ""
	Data.s "onevent,onchange,onfocus,onlostfocus,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_Date, 0, 0, 0, 0, 0, 0, 0
	Data.s "date"
	Data.s "#PB_Date_UpDown", "#PB_Date_CheckBox", ""
	Data.s "onevent,onchange"
	;
	Data.i #DialogType_Editor, 0, 0, 0, 0, 0, 0, 0
	Data.s "editor"
	Data.s "#PB_Editor_ReadOnly", "#PB_Editor_WordWrap", ""
	Data.s "onevent"
	;
	Data.i #DialogType_Empty, 0, 0, 0, 0, 0, 0, 0
	Data.s "empty", ""
	Data.s ""
	;
	Data.i #DialogType_ExplorerCombo, 0, 0, 0, 0, 0, 0, 0
	Data.s "explorercombo"
	Data.s "#PB_Explorer_DrivesOnly", "#PB_Explorer_Editable", "#PB_Explorer_NoMyDocuments", ""
	Data.s "onevent"
	;
	Data.i #DialogType_ExplorerList, 0, 0, 0, 0, 0, 0, 0
	Data.s "explorerlist"
	Data.s "#PB_Explorer_BorderLess", "#PB_Explorer_AlwaysShowSelection", "#PB_Explorer_MultiSelect", "#PB_Explorer_GridLines", "#PB_Explorer_HeaderDragDrop"
	Data.s "#PB_Explorer_FullRowSelect", "#PB_Explorer_NoFiles", "#PB_Explorer_NoFolders", "#PB_Explorer_NoParentFolder", "#PB_Explorer_NoDirectoryChange"
	Data.s "#PB_Explorer_NoDriveRequester", "#PB_Explorer_NoSort", "#PB_Explorer_NoMyDocuments", "#PB_Explorer_AutoSort", ""
	Data.s "onevent,onchange,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_ExplorerTree, 0, 0, 0, 0, 0, 0, 0
	Data.s "explorertree"
	Data.s "#PB_Explorer_BorderLess", "#PB_Explorer_AlwaysShowSelection", "#PB_Explorer_NoLines", "#PB_Explorer_NoButtons", "#PB_Explorer_NoFiles"
	Data.s "#PB_Explorer_NoDriveRequester", "#PB_Explorer_NoMyDocuments", "#PB_Explorer_AutoSort", ""
	Data.s "onevent,onchange,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_Frame, 1, -1, 0, 0, 0, 0, 0
	Data.s "frame"
	Data.s "" ;removed, see => https://www.purebasic.fr/english/viewtopic.php?f=37&t=72383
	Data.s "onevent,onchange,onfocus,onlostfocus,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_HyperLink, 0, 0, 0, 0, 0, 0, 0
	Data.s "hyperlink"
	Data.s "#PB_Hyperlink_Underline", ""
	Data.s "onevent"
	;
	Data.i #DialogType_Image, 0, 0, 0, 0, 0, 0, 0
	Data.s "image"
	Data.s "#PB_Image_Border", ""
	Data.s "onevent,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_IPAddress, 0, 0, 0, 0, 0, 0, 0
	Data.s "ipaddress", ""
	Data.s "onevent"
	;
	Data.i #DialogType_ListIcon, 0, 0, 0, 0, 0, 0, 0
	Data.s "listicon"
	Data.s "#PB_ListIcon_CheckBoxes", "#PB_ListIcon_ThreeState", "#PB_ListIcon_MultiSelect", "#PB_ListIcon_GridLines", "#PB_ListIcon_FullRowSelect"
	Data.s "#PB_ListIcon_HeaderDragDrop", "#PB_ListIcon_AlwaysShowSelection", ""
	Data.s "onevent,onchange,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_ListView, 0, 0, 0, 0, 0, 0, 0
	Data.s "listview"
	Data.s "#PB_ListView_Multiselect", "#PB_ListView_ClickSelect", ""
	Data.s "onevent,onleftclick,onleftdoubleclick"
	;
	Data.i #DialogType_Option, 0, 0, 0, 0, 0, 1, 0
	Data.s "option", ""
	Data.s "onevent"
	;
	Data.i #DialogType_Panel, -1, #DialogType_Tab, 0, 0, 0, 0, 0
	Data.s "panel", ""
	Data.s "onevent,onchange"
	;
	Data.i #DialogType_ProgressBar, 0, 0, 1, 1, 1, 0, 0
	Data.s "progressbar"
	Data.s "#PB_ProgressBar_Smooth", "#PB_ProgressBar_Vertical", ""
	Data.s "onevent"
	;
	Data.i #DialogType_Scintilla, 0, 0, 0, 0, 0, 0, 0
	Data.s "scintilla", ""
	Data.s "onevent"
	;
	Data.i #DialogType_ScrollArea, 1, -1, 0, 0, 0, 0, 0
	Data.s "scrollarea"
	Data.s "#PB_ScrollArea_Flat", "#PB_ScrollArea_Raised", "#PB_ScrollArea_Single", "#PB_ScrollArea_BorderLess", "#PB_ScrollArea_Center", ""
	Data.s "onevent,onchange,onfocus,onlostfocus,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_ScrollBar, 0, 0, 1, 1, 0, 0, 1
	Data.s "scrollbar"
	Data.s "#PB_ScrollBar_Vertical", ""
	Data.s "onevent"
	;
	Data.i #DialogType_Spin, 0, 0, 1, 1, 1, 0, 0
	Data.s "spin"
	Data.s "#PB_Spin_ReadOnly", "#PB_Spin_Numeric", ""
	Data.s "onevent,onchange"
	;
	Data.i #DialogType_Splitter, 2, -1, 0, 0, 0, 0, 0
	Data.s "splitter"
	Data.s "#PB_Splitter_Vertical", "#PB_Splitter_Separator", "#PB_Splitter_FirstFixed", "#PB_Splitter_SecondFixed", ""
	Data.s "onevent,onchange,onfocus,onlostfocus,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_String, 0, 0, 0, 0, 0, 0, 0
	Data.s "string"
	Data.s "#PB_String_Numeric", "#PB_String_Password", "#PB_String_ReadOnly", "#PB_String_LowerCase", "#PB_String_UpperCase", "#PB_String_BorderLess", ""
	Data.s "onevent,onchange,onfocus,onlostfocus"
	;
	Data.i #DialogType_Tab, 1, -1, 0, 0, 0, 0, 0
	Data.s "tab", ""
	Data.s "onevent,onchange,onfocus,onlostfocus,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_Text, 0, 0, 0, 0, 0, 0, 0
	Data.s "text"
	Data.s "#PB_Text_Center", "#PB_Text_Right", "#PB_Text_Border", ""
	Data.s "onevent"
	;
	Data.i #DialogType_TrackBar, 0, 0, 1, 1, 1, 0, 0
	Data.s "trackbar"
	Data.s "#PB_TrackBar_Ticks", "#PB_TrackBar_Vertical", ""
	Data.s "onevent"
	;
	Data.i #DialogType_Tree, 0, 0, 0, 0, 0, 0, 0
	Data.s "tree"
	Data.s "#PB_Tree_AlwaysShowSelection", "#PB_Tree_NoLines", "#PB_Tree_NoButtons", "#PB_Tree_CheckBoxes", "#PB_Tree_ThreeState", ""
	Data.s "onevent,onchange,ondragstart,onrightclick,onleftclick,onrightdoubleclick,onleftdoubleclick"
	;
	Data.i #DialogType_Web, 0, 0, 0, 0, 0, 0, 0
	Data.s "web", ""
	Data.s "onevent"
	;
	Data.i #DialogType_HBox, -1, -1, 0, 0, 0, 0, 0
	Data.s "hbox", ""
	Data.s ""
	;
	Data.i #DialogType_VBox, -1, -1, 0, 0, 0, 0, 0
	Data.s "vbox", ""
	Data.s ""
	;
	Data.i #DialogType_GridBox, -1, -1, 0, 0, 0, 0, 0
	Data.s "gridbox", ""
	Data.s ""
	;
	Data.i #DialogType_MultiBox, -1, -1, 0, 0, 0, 0, 0
	Data.s "multibox", ""
	Data.s ""
	;
	Data.i #DialogType_SingleBox, 1, -1, 0, 0, 0, 0, 0
	Data.s "singlebox", ""
	Data.s ""
	;
	Data.i -1 ;end
						;
	PossibleAttributes:
	Data.s "width", "height", "_name", "text", "flags", "min", "max", "value", "invisible", "disabled", "colspan", "rowspan", "minwidth", "maxwidth", "minheight", "maxheight"
	Data.s "spacing", "expand", "align", "columns", "colspacing", "rowspacing", "colexpand", "rowexpand", "colspan", "rowspan", "margin", "expandwidth", "expandheight"
	Data.s "scrolling", "innerheight", "innerwidth", "step", "_id", "_onevent", "_onchange", "_onfocus", "_onlostfocus", "_ondragstart"
	Data.s "_onrightclick", "_onleftclick", "_onrightdoubleclick", "_onleftdoubleclick", "secondmin", "firstmin", "group", ""
	;
	ConstantSavingData:
	Data.s "_onevent", "_onchange", "_onfocus", "_onlostfocus", "_ondragstart", "_onrightclick", "_onleftclick", "_onrightdoubleclick", "_onleftdoubleclick", ""
	
	
	MainDialog:
	IncludeBinary "dd.xml"
	MainDialogEnd:
	IncludeBinary "english.lan"
	MainIcons:
	IncludeBinary "master.png"
EndDataSection
;}
; IDE Options = PureBasic 5.71 beta 1 LTS (Windows - x86)
; CursorPosition = 4
; Folding = AAYAAgBAAgAAAAAAAAAAAAAA+
; EnableXP
; EnableUser
; DPIAware
; UseIcon = Tools.ico
; Executable = dd_x64.exe
; CompileSourceDirectory
; EnableCompileCount = 1034
; EnableBuildCount = 10
; EnableExeConstant
; EnableUnicode