﻿#XmlEncoding = #PB_UTF8

#Dialog = 0
#Xml = 0

Runtime Enumeration Gadget
	#ListView
	#GeneralContainer
	#EditorContainer
	#BackupContainer
EndEnumeration

Procedure ShowPanels()
	
	HideGadget(#GeneralContainer, #True)
	HideGadget(#EditorContainer, #True) 
	HideGadget(#BackupContainer, #True)
	
	Select GetGadgetState(#ListView)
		Case 0
			HideGadget(#GeneralContainer, #False)
			
		Case 1
			HideGadget(#EditorContainer, #False)
			
		Case 2
			HideGadget(#BackupContainer, #False)
	EndSelect
EndProcedure

Runtime Procedure OnListViewEvent()
	ShowPanels()
EndProcedure

XML$ = "<window id='#PB_Any' name='test' text='Preferences' minwidth='auto' minheight='auto' flags='#PB_Window_ScreenCentered | #PB_Window_SystemMenu | #PB_Window_SizeGadget'>" +
       "  <hbox expand='item:2'>" +
       "    <listview id='#ListView' width='100' onEvent='OnListViewEvent()'/>" +
       "    <multibox>" +
       "" +
       "      <container id='#GeneralContainer' invisible='yes'>" +
       "        <frame text='General'>" +
       "          <vbox expand='no'>" +
       "            <checkbox text='Enable red light'/>" +
       "            <checkbox text='Enable green light'/>" +
       "          </vbox>" +
       "        </frame>" +
       "      </container>" +
       "" +
       "      <container id='#EditorContainer' invisible='yes'>" +
       "        <frame text='Editor'>" +
       "          <vbox expand='no'>" +
       "            <checkbox text='Set read only mode'/>" +
       "            <checkbox text='Duplicate line automatically'/>" +
       "            <checkbox text='Enable monospace font'/>" +
       "          </vbox>" +
       "        </frame>" +
       "      </container>" +
       "" +
       "      <container  id='#BackupContainer' invisible='yes'>" +
       "      <frame text='Backup'>" +
       "        <vbox expand='no'>" +
       "          <checkbox text='Activate backup'/>" +
       "        </vbox>" +
       "      </frame>" +
       "      </container>" +
       "" +
       "    </multibox>" +
       "  </hbox>" +
       "</window>"

If CatchXML(#Xml, @XML$, StringByteLength(XML$), 0, #XmlEncoding) And XMLStatus(#Xml) = #PB_XML_Success
	
	If CreateDialog(#Dialog) And OpenXMLDialog(#Dialog, #Xml, "test")
		
		AddGadgetItem(#ListView, -1, "General")
		AddGadgetItem(#ListView, -1, "Editor")
		AddGadgetItem(#ListView, -1, "Backup")
		
		SetGadgetState(#ListView, 0)
		
		ShowPanels()
		
		Repeat
			Event = WaitWindowEvent()
		Until Event = #PB_Event_CloseWindow 
		
	Else  
		Debug "Dialog error: " + DialogError(#Dialog)
	EndIf
Else
	Debug "XML error: " + XMLError(#Xml) + " (Line: " + XMLErrorLine(#Xml) + ")"
EndIf

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 92
; FirstLine = 34
; Folding = -
; EnableXP
; EnableUser
; CompileSourceDirectory
; EnableCompileCount = 3
; EnableBuildCount = 0